;PENO Football par Joe14 (MYP).											
;Version : 1.0															
;Date d'achvement : 13/03/2007 22h18									
;Taille : 2609 octets (TI 83 PLUS) 2597 octets (TI 83)					
;Plates-formes : format ION ; TI 83, 83 PLUS [SE], 84, 84 Plus			
;Edit  l'aide de Crimson editor v. 3.7								
;Merci  David de Cirrus programming pour ses syntaxfiles trs pratiques
;


;note :  certains endroits apparat la mention "SELF MODIFYING CODE" que j'ai trouve
;plus parlante que son quivalent franais. Cette mention permet  la fois d'identifier
;les parties du code qui sont "reprogrammes" lors de l'excution et les parties du code
;qui ralisent cette reprogrammation.

.NOLIST			;(facultatif)

;Dclarations obligatoires.

#define end .end	;Ces dclarations assurent la compatibilit du code avec TASM.
#define END .end	;Ainsi, lors de la compilation : end = .end = END...
#define equ .equ
#define EQU .equ

;Librairie utilise.

#include "dwedit.inc"	;Cette ligne indique au compilateur quelle librairie
						;utiliser pour remplacer les alias par les adresses mmoires
						;appropries (en fonction de la calculatrice pour laquelle
						;on compile). Ici, il s'agit de dwedit.inc v 5.08.
						;Adresse du site personnel de l'auteur :
						;http://home.attbi.com/~alanweiss3/dwedit/ti/index.html
						;Auteur de bubble bobble et de ce fichier d'include trs pratique,
						;car il permet de compiler facilement son programme pour plusieurs
						;modles de calculatrices TI Z80.
						;MERCI A LUI.

;Dfinition des variables.

modejeux = SAFERAM3		;				modes possibles : 16 = "1 joueur anonyme"
						;				24 = "2 joueurs anonymes" ; 32 = "1 joueur"
						;				40 = "2 joueurs".
lignespace = modejeux+1	;(SAFERAM3+1)	Cette variable sert  effacer la ligne
						;				d'information place au bas de l'cran de jeu.
						;				Elle est initialise avec des espaces (voir
						;				au label "debut:").
;Fin de la variable enregistre  l'adresse lignespace = lignespace+65 (SAFERAM3+66).
;lignespace+66 (SAFERAM3+67) = $00
ntirs = lignespace+67	;(SAFERAM3+68)	Nombre de tirs choisi (5, 10, 15, 20, 25 ou 30).
ntirs1 = ntirs+1		;(SAFERAM3+69)	Nombre de tirs effectus par le joueur 1.
ntirs2 = ntirs1+1		;(SAFERAM3+70)	Nombre de tirs effectus par le joueur 2.
;Les trois variables prcdentes doivent se suivre (voir "compteur:").
ordretir = ntirs2+1		;(SAFERAM3+71)	(0 = "joueur 1 tire" ; 1 = "joueur 2 tire" ;
						;				3 = "fin de la squence")
bj1 = ordretir+1		;(SAFERAM3+72)	Nombre de buts du joueur 1.
bj2 = bj1+1				;(SAFERAM3+73)	Nombre de buts du joueur 2.
;Les deux variables bj1 et bj2 doivent se suivre (voir "compteur:").
tir = bj2+1				;(SAFERAM3+74)	Sert  contenir le code de la touche presse
						;				par le tireur.
stoppe = tir+1			;(SAFERAM3+75)	Sert  contenir le code de la touche presse
						;				par le gardien.
result = stoppe+1		;(SAFERAM3+76)	0 si la squence de tir prcdente n'a pas
						;				donn lieu  un but. 1 sinon.
aleatoire = result+1	;(SAFERAM3+77)	Variable de stockage d'un nombre "alatoire".
nomj1 = aleatoire+1		;(SAFERAM3+78)	Nom du joueur 1. (une chane de 10 octets encadre
						;				de deux %00)
nomj2 = nomj1+11		;(SAFERAM3+89)	Nom du joueur 2. (idem. Remarque : dans le cas o le
						;				nom du joueur 1 fait effectivement dix caractres, le
						;				%00 plac aprs la chane lie au nom du joueur 1 est
						;				aussi le %00 prcdant la chane lie au nom du joueur 2.
;Fin de la variable enregistre  l'adresse nomj2 = nomj2+11 (SAFERAM3+100)
nligzone = nomj2+12		;(SAFERAM3+101)	Nombre de lignes de 4 octets accessibles pour
						;				l'affichage du ballon pour la zone choisie. Peut
						;				valoir 13 (zones suprieures), 12 (zones mdianes)
						;				ou 3 (zones infrieures).
adballon = nligzone+1	;(SAFERAM3+101)	Variable dans laquelle est stocke l'adresse o est
						;				copi le ballon.
;Fin de la variable enregistre  l'adresse adballon = adballon+1 (SAFERAM3+102), car c'est
;										une adresse (16 bits) qui est sauve dans adballon.
adresortie = adballon+2	;(SAFERAM3+103)	Variable de stockage de l'adresse  laquelle le PC
						;				se trouvait avant le lancement de Peno football.
;Fin de la variable enregistre  l'adresse adresortie = adresortie+1 (SAFERAM3+104), car c'est
;										une adresse (16 bits) qui est sauve dans adresortie.

;Dbut du code.

.LIST			;(facultatif)

tTitle:
							;L'utilisation de "tTitle" et "lblstart" est impose par DWEDIT.inc
							;(voir ce dernier pour plus d'informations).
 .db    "PENO football",0	;Explication : cette chane de caractres sert  nommer le programme
							;dans les shells tels que ION ou MirageOS. Le 0 indique  plusieurs
							;ROM_CALLS comme "vputs" la fin de la chane de caractres.

;Dbut du programme.

lblstart:

;Initialisation des system flags.

 res appTextSave,(iy+appflags)		;Dsactivation de la sauvegarde de l'cran texte
									;car elle utilise la SAFERAM3 
									;(utilise par les variables utilisateurs dfinies plus haut).
 res TextInverse,(iy+TextFlags)		;On place le drapeau relatif  l'affichage en mode noir sur fond blanc.
 res 2,(iy+50)						;"res FracDrawLFont,(iy+FontFlags)"
 res textEraseBelow,(iy+TextFlags)	;Empche la ligne situe sous les caractres
									;minuscules d'tre efface (sic)... Bon, en
									;gros, c'est la position normale, donc... :)
 im 1								;Les interruptions du TI-OS sont actives.
 ld a,%00010110						;Code de vitesse normale (1:200s) d'interruptions.
 out (4),a							;Rglage de la vitesse des interruptions.


;Rglage de la vitesse du processeur dans le cas o il s'agirait d'une TI 83 + SE.
;Les indications concernant ce code viennent d'un document (SPEED.txt) de Michael VINCENT.
;Qu'il me soit permis d'exprimer,  cette occasion, tout mon respect pour ce gars-l qui connat
;les TI Z80 mieux que n'importe qui ( part peut-tre quelques ingnieurs de chez TI, et encore...).
;Il est l'auteur de quelques-unes des plus clbres applications 83+ (emu8x, par exemple, et ce
;n'est pas la seule).
;Adresse de son site personnel : http://www.michaelv.org/
;Allez-y, c'est une mine d'informations.

#ifdef TI83P	;Les lignes qui suivent s'adressent  la TI 83 PLUS uniquement.
 xor a			;Met a  zro.
 out (20h),a	;Rgle la vitesse du processeur  6 MHz (pour viter des ennuis avec ma temporisation).
#endif			;Fin de la diffrenciation (entre la TI 83 PLUS et les autres).

;Initialisation des variables.

debut:
							;Initialisation de lignespace.
	bcall(_cleartextshad)	;Cette routine copie des espaces ($20) dans tous les octets
							;de la SAFERAM3. Ainsi, lignespace est remplie d'espaces.
							;Initialisation des variables restantes.
 ld hl,lignespace+66
 ld b,10
initialisation:				;Met  zro une dizaine de variables.
 xor a
 ld (hl),a
 inc hl
 djnz initialisation
;Sauvegarde de l'adresse de la pile o est stocke l'adresse du PC avant le lancement du programme.
 ld (adresortie),sp			;Cette adresse servira  quitter le programme rapidement.

;Cration du menu initial.

retouraide:
 call lignemenu		;Saute  la partie du code qui trace les lignes du menu.
					;C'est l'quivalent d'un saut, sauf que l'adresse  laquelle
					;se trouve la commande suivante ("call menu1") est stocke
					;dans la pile afin d'y revenir, lorsque l'on rencontrera un
					;"ret".
 call menu1			;Saute  la partie du code qui affiche les textes du menu initial.
 call getkey1		;Saute  la partie du code qui gre le curseur.
 call enter			;Saute  la partie du code qui,  partir des coordonnes du
					;curseur, aiguille l'excution vers la partie du code adapte
					;au choix de l'utilisateur.
 cp 56				;Vrifie si penrow (dont la valeur est,  ce moment de
					;l'excution, contenue dans a) vaut 56 (correspondant au
					;choix de "sortie" par l'utilisateur).
 jp z,sortie		;Si oui, l'utilisateur quitte le programme.

;Cration du second menu qui permet de choisir le nombre de tirs.

getkey2:
 call lignemenu		;Saute  la partie du code qui trace les lignes du menu.
 call nbretirs		;Saute  la partie du code qui affiche les textes du menu.
 call getkey1		;Saute  la partie du code qui gre le curseur.

;Affectation du nombre de tirs selon validation du second menu.

enter2:
 ld hl,(penrow)		;Charge (penrow) dans l, pour dterminer  quelle ligne du menu
					;l'utilisateur a valid.
 ld a,16			;Charge la valeur de (penrow) lie  la premire ligne du menu dans a.
 ld c,5				;Nombre de tirs correspondant  la premire ligne du menu.
rebouclecurs:		;Rinitialisation de la boucle de dtermination du nombre de tirs.
 ld b,5				;Ecart entre chaque nombre de tirs (5, 10, 15, ... => +5  chaque ligne).
bouclecurs:			;Cette boucle permet de faire correspondre le nombre de tirs avec la ligne du menu.
					;Ainsi, quand a = 24, c = 10, quand a = 32, c = 15... et de quitter la boucle au
					;moment o la valeur de c correspond  la ligne du menu o se trouvait le curseur
					; l'instant o l'utilisateur a valid.
 cp l				;Compare (penrow)  a.
 jr z,nombretirs	;Si a = (penrow), va  "nombretirs:".
 inc c				;Sinon, on incrmente c.
 djnz bouclecurs	;Si b est diffrent de 1 avant le "djnz", on va  "bouclecurs:".
 add a,8			;Si b vaut 0, on ajoute 8  a pour obtenir la valeur possible de (penrow) suivante.
 jr rebouclecurs	;Relance la boucle djnz bouclecurs en prenant soin de recharger b d'abord.
					;Remarque : le nombre de tests effectus est 5 fois plus grand que le nombre de tests
					;ncessaires... Cette mthode nous permet cependant d'viter une opration d'addition
					;(optimisation en taille).

;Retour au menu principal aprs la fin d'une partie.

fin:
 call introwaitkey2		;On attend que l'utilisateur presse une touche
 jr debut				;avant de revenir au menu principal.


nombretirs:
 ld a,c				;
 ld (ntirs),a		;Charge dans (ntirs) le nombre de tirs choisi par l'utilisateur.

;Affichage de la premire partie de l'cran de jeu.

					;Dcompression de l'image code en RLE dans la mmoire
					;graphique (graph buffer).
 ld hl,cage			;Charge dans hl l'adresse de dbut des donnes  dcompresser.
 ld bc,288			;288 est le nombre d'octets  dcompresser.
 call Decompress1	;Appel de la routine de dcompression RLE.

;Dbut des squences de tirs.

reactualisationecran: 

;Rinitialisation de l'affichage du filet afin d'effacer le sprite du gardien
;(vite de rafficher tout l'cran de jeux).

 call affcage					;Raffiche le filet pour effacer les sprites prcdents.
 call gardieninitial			;Appelle la routine qui place le sprite du gardien en
								;position initiale.

;Affichage des informations de l'cran.

 set textinverse,(iy+textflags)	;Active l'criture blanche sur fond noir. En
								;effet, les routines _vputs et _vputmap tiennent
								;compte de ce flag (c'est plus rapide  crire
								;que drapeau).
 set TextWrite,(iy+SGrFlags)	;Active la sauvegarde de ce qui est crit 
								;l'cran ( l'aide des routines susdites) dans le
								;graph buffer. Ainsi, l'utilisation de la routine
								;ionfastcopy, ncessaire  l'affichage des graphismes
								;n'effacera pas les inscriptions.

;Premire colonne, le nom des joueurs.

 ld hl,$0000			;
 ld (pencol),hl			;(Penrow) = $00 et (pencol) = $00.
 ex de,hl				;Sauve hl dans de. L'utilisation de la pile pour cela est
						;impossible, du fait du code qui suit :
						;voir [affnomsecran - jr nz,affnomsecran].
 ld hl,dispjoueur+1		;Charge l'adresse de "joueur" dans hl.
	bcall(_vputs)		;Affiche "joueur" en haut  gauche de l'cran et sauvegarde le
						;code associ dans le graph buffer.
 ld a,$3A				;Charge le code du caractre ":" dans a.
 push de				;Sauve le contenu de de dans la pile.
	bcall(_vputmap)		;Affiche ":" aprs "joueur"  l'cran et rpercute cette
						;modification dans le graph buffer.
 pop de					;Rcupre la valeur de de stocke dans la pile.
 ld hl,nomj1+1			;Charge dans hl l'adresse du nom du premier joueur.
affnomsecran:
 ld a,$3A				;Charge le code du caractre ":" dans a.
 ld bc,$0700			;Charge dans bc la valeur  ajouter  hl pour passer  la ligne
						;suivante.
 ex de,hl				;Echange de et hl, car hl est ncessaire pour l'utilisation
						;de add et ld (pencol),hl (1 octet de moins que ld (pencol),de).
 add hl,bc				;
 ld (pencol),hl			;Passe  la ligne suivante.
 ex de,hl				;Echange  nouveau les contenus de hl et de.
 push de				;Sauvegarde de dans la pile  cause de _vputs et _vputmap.
	bcall(_vputs)		;Affiche le nom du premier joueur et modifie le graph buffer en
						;consquence.
	bcall(_vputmap)		;Affiche ":" et modifie le graph buffer en consquence.
 ld hl,nomj2+1			;Charge l'adresse o est stock le nom du second joueur dans hl.
 pop de					;Rcupre la valeur de de stocke prcdemment dans la pile.
 ld a,d					;Prpare le test de fin de boucle.
 sub 14					;Si a(=d)=14=$E=(penrow), cela signifie que l'on a affich les
						;deux noms des joueurs.
 jr nz,affnomsecran		;Dans le cas contraire, on retourne  "affnomsecran:" afin d'afficher
						;le deuxime nom.

;Deuxime colonne, le nombre de tirs.

 ld hl,$0030			;
 ld (pencol),hl			;(Penrow) = $00 et (pencol) = $30.
 ld hl,disptirs			;Charge l'adresse o est stock "tirs" dans hl.
	bcall(_vputs)		;Affiche "tirs" et modifie le graph buffer en consquence.
 ld a,$3A				;Charge dans a le code du caractre ":".
	bcall(_vputmap)		;Affiche ":"  la suite de tirs et modifie le graph buffer en
						;consquence.
 ld hl,$0730			;Prpare l'excution de la partie de code appele par
						;call afftirs. Le contenu de hl sert  charger (penrow-col).
 ld a,(ntirs1)			;Charge dans a le nombre de tirs effectus par le joueur 1.
 call afftirs			;Appelle la partie de code qui affiche le nombre contenu dans
 						;a  l'adresse contenue dans hl  l'cran et dans le graph buffer.
 ld hl,$0E30			;Prpare le passage  la ligne suivante.
 ld a,(ntirs2)			;Prpare l'affichage du nombre de tirs du joueur 2.
 call afftirs			;Mme chose que 3 lignes plus haut, mais pour le joueur 2.

;Troisime colonne, le nombre de buts.

 ld hl,$004B			;
 ld (pencol),hl			;Place penrow-col au bon endroit.
 ld hl,dispbuts			;Charge l'adresse o est stock "buts:" dans hl.
	bcall(_vputs)		;Affiche "buts:" et met  jour le graph buffer.
 ld hl,$0750			;Prpare la mise  jour de (penrow-col) afin d'afficher le nombre
						;de buts du joueur 1.
 ld a,(bj1)				;Charge dans a le nombre de buts du joueur 1.
 call affbuts			;Appelle la partie du code qui affiche les nombres de buts d'aprs
						;les contenus de a et hl.
 ld hl,$0E50			;
 ld a,(bj2)				;
 call affbuts			;Mme chose que prcdemment avec le joueur 2.

 res textinverse,(iy+textflags) ;Repasse en mode texte noir sur fond blanc.
 res TextWrite,(iy+SGrFlags)	;Ce qui sera dsormais crit en minuscules  l'aide des
								;routines du TI-OS (_vputs, _vputmap...) ne sera pas 
								;sauv dans le graph buffer.
 call ionFastCopy		;Appel de la routine ION d'affichage du graph buffer  l'cran.


;Redirection selon le mode de jeu.

redirection:
 ld b,2				;Dfinit le nombre d'itrations de la boucle [djnz - redboucle:].
 ld a,(modejeux)	;Charge le contenu de modejeux dans a afin de comparer cette
					;valeur aux valeurs possibles.
 ld h,16			;Premire valeur avec laquelle on va comparer a.
redboucle:			;Dbut de la boucle de redirection.
 sub h				;Effectue a-h = a.
 jr z,red1j			;Si (modejeux) = 16 ou 32, on est dans un mode de jeu pour 1 joueur.
 djnz redboucle		;Aprs avoir "compar" (modejeux)  16, on va "comparer" (modejeux)  32.

;Redirection du mode 2 joueurs selon l'ordre de tir.

 ld hl,nomj2+1		;Charge l'adresse o est stock le nom du joueur 2. (nomj2) = 0.
 ld a,(ordretir)	;On regarde quel joueur doit tirer.
 dec a				;a-1=a
 jr z,a2getkey		;Si (ordretir) = 1, le joueur 2 tire et le joueur 1 stoppe.
 jp p,fin			;Si (ordretir) = 2, la sance de tirs est finie.
 ld hl,nomj1+1		;Si (ordretir) = 0, le joueur 1 tire et le joueur 2 stoppe.
					;Il faut donc charger dans hl l'adresse o est stock le nom
					;du joueur 1. (nomj1) = 0.

;Squence de tir du joueur dont le nom est stock  l'adresse contenue dans
;hl et d'arrt de l'autre joueur (mode 2 joueurs).

a2getkey:
 call affjtire				;Saute  la routine d'affichage du texte contenu dans hl suivi de "frappe".
 call getkeytir				;Saute  la routine de gestion du tir utilisateur.
 call effjts				;Saute  la routine d'effaage du texte crit en bas.
 ld hl,nomj1+1				;Charge l'adresse du nom du joueur 1 dans hl. Rappel : (nomj1) = 0.
 ld a,(ordretir)			;
 dec a						;Dtermine quel joueur doit stopper.
 jr z,a2getkey2				;(ordretir) = 1, donc le joueur 1 stoppe.
 ld hl,nomj2+1				;(ordretir) = 0, donc le joueur 2 stoppe.
a2getkey2:
 call affjstoppe			;Saute  la routine d'affichage du texte contenu dans hl suivi de "stoppe".
 call getkeyarret			;Saute  la routine de gestion de l'arrt utilisateur.
 call effjts				;Saute  la routine d'effaage du texte crit en bas.
 call animation				;Saute  l'affichage de l'animation (rudimentaire...).
; call calcresult
 call compteur				;Saute  l'actualisation des compteurs.
reactualisationecranbis:	;Ce label permet d'conomiser deux octets en utilisant des jr  la place de jp.
 jp reactualisationecran	;Relance une squence de tir.

;Effaage de la mention "[joueur] tire" ou "[joueur] stoppe".

effjts:
 ld hl,$3900		;
 ld (pencol),hl		;Place le penrow-col  l'adresse de dbut de la ligne qu'il faut effacer.
 ld hl,lignespace	;Charge dans l'adresse o est stocke la ligne constitue d'espaces.
#ifdef TI83P		;Ce qui suit est compil pour la TI 83+ uniquement.
	bcall(_vputs)	;Affiche la ligne d'espaces  l'cran.
 ret				;Va  l'adresse suivant "call effjts".
#else				;Ce qui suit est ignor pour la TI 83+ uniquement.
 jp _vputs			;Affiche la ligne d'espaces  l'cran et va  l'adresse suivant "call effjts".
#endif				;Fin de la diffrenciation.

;Redirection du mode 1 joueur selon l'ordre de tir.

red1j:
 ld a,(ordretir)	;On regarde si le joueur doit tirer, stopper ou finir la sance.
 dec a				;
 jr z,a1getkey2		;Si (ordretir) = 1, le joueur doit stopper.
 jp p,fin			;Si (ordretir) = 2, la sance de tirs est finie.
; jp a1getkey1		;Si (ordretir) = 0, le joueur doit tirer.

;affiche "[nom du joueur] frappe" (mode 1 joueur).

a1getkey1:
 ld hl,nomj1+1				;Charge l'adresse du nom du joueur 1 dans hl. Rappel : (nomj1) = 0.
 call affjtire				;Saute  la routine d'affichage du texte contenu dans hl suivi de "frappe".
 call getkeytir				;Saute  la routine de gestion du tir utilisateur.
 call suite					;Saute  la routine de calcul du choix du gardien ordinateur.
; call animation			;Saute  l'affichage de l'animation.
; call calcresult			;C'est compris dans suite.
 call compteur				;Saute  la mise  jour des compteurs.
 jr reactualisationecranbis	;Relance une squence de tir.
 
;Affichage de la mention "[nom du joueur] tire" (mode 1 joueur).

affjtire:
 ld de,$3900		;Utilise de, car le contenu de hl est ncessaire.
 ld (pencol),de		;Place le penrow-col  l'adresse de dbut de la ligne o on veut crire.
	bcall(_vputs)	;Affiche le nom du joueur  l'cran.
 ld hl,disptire		;Charge l'adresse o est stock "frappe" dans hl.
#ifdef TI83P		;Ce qui suit est compil pour la TI 83+ uniquement.
	bcall(_vputs)	;Affiche "[nom du joueur] frappe"  l'cran.
 ret				;Va  l'adresse suivant "call affjtire".
#else				;Ce qui suit est ignor pour la TI 83+ uniquement.
 jp _vputs			;Affiche "[nom du joueur] frappe"  l'cran et va  l'adresse suivant
					;"call affjtire".
#endif				;Fin de la diffrenciation.

;affiche le nom du joueur et "stoppe".

a1getkey2:					;Getkey utilis lorsque le joueur 1 stoppe.
 ld hl,nomj1+1				;Charge l'adresse du nom du joueur 1 dans hl. Rappel : (nomj1) = 0.
 call affjstoppe			;Saute  la routine d'affichage du texte contenu dans hl suivi de "stoppe".
 call getkeyarret			;Saute  la routine de gestion de l'arrt utilisateur.
 call suite2				;Saute  la routine de calcul du choix du tireur ordinateur.
; call animation			;C'est compris dans suite2.
; call calcresult			;C'est compris dans suite2.
 call compteur				;Saute  l'actualisation des compteurs.
 jr reactualisationecranbis	;Relance une squence de tir.

;Affichage de la mention "[nom du joueur] stoppe".

affjstoppe:
 ld de,$3900		;Utilise de, car le contenu de hl est ncessaire.
 ld (pencol),de		;Place le penrow-col  l'adresse de dbut de la ligne o on veut crire.
 	bcall(_vputs)	;Affiche le nom du joueur  l'cran.
 ld hl,dispstoppe	;Charge l'adresse o est stock "stoppe" dans hl.
#ifdef TI83P		;Ce qui suit est compil pour la TI 83+ uniquement.
	bcall(_vputs)	;Affiche "[nom du joueur] stoppe"  l'cran.
 ret				;Va  l'adresse suivant "call affjstoppe".
#else				;Ce qui suit est ignor pour la TI 83+ uniquement.
 jp _vputs			;Affiche "[nom du joueur] stoppe"  l'cran et va  l'adresse suivant
					;"call affjstoppe".
#endif				;Fin de la diffrenciation.

;Ecriture des nombres de tirs.
 
afftirs:				;a comprend le nombre de tirs que l'on veut afficher.
 ld (pencol),hl			;hl comprend l'adresse du graph buffer o l'on souhaite placer
						;le nombre de tirs.
	bcall(_setxxop1)	;Charge a dans OP1.
 ld a,2					;Rgle le nombre maximum de chiffres qu'affichera _dispop1a (2).
	bcall(_dispop1a)	;Affiche le contenu de OP1  l'adresse penrow-col.
 ld a,$D1				;Charge dans a le code du caractre "/".
	bcall(_vputmap)		;Affiche "/"  l'adresse penrow-col.
 ld a,(ntirs)			;Charge le nombre de tirs dans a.
	bcall(_setxxop1)	;Charge a dans OP1.
; ld a,2				;Inutile, car a > 2.
#ifdef TI83P			;Ce qui suit est compil pour la TI 83+ uniquement.
	bcall(_dispop1a)	;Affiche le contenu de OP1  l'adresse penrow-col.
 ret					;Va  l'adresse suivant "call affjstoppe".
#else					;Ce qui suit est ignor pour la TI 83+ uniquement.
 jp _dispop1a			;Affiche le contenu de OP1  l'adresse penrow-col et va 
						;l'adresse suivant "call afftirs".
#endif					;Fin de la diffrenciation.

;Ecriture des nombres de buts.

affbuts:				;a comprend le nombre de buts que l'on veut afficher.
 ld (pencol),hl			;hl comprend l'adresse du graph buffer o l'on souhaite placer
						;le nombre de buts.
	bcall(_setxxop1)	;Charge a dans OP1.
 ld a,2					;Rgle le nombre maximum de chiffres qu'affichera _dispop1a (2).
#ifdef TI83P			;Ce qui suit est compil pour la TI 83+ uniquement.
	bcall(_dispop1a)	;Affiche le contenu de OP1  l'adresse penrow-col.
 ret					;Va  l'adresse suivant "call affbuts".
#else					;Ce qui suit est ignor pour la TI 83+ uniquement.
 jp _dispop1a			;Affiche le contenu de OP1  l'adresse penrow-col et va 
						;l'adresse suivant "call affbuts".
#endif					;Fin de la diffrenciation.

;Traage des lignes des menus.

lignemenu:
 set TextWrite,(iy+SGrFlags)	;Active la sauvegarde de ce qui est crit par les
								;routines _vputs et _vputmap dans le graph buffer.
	bcall(_cleargbuf)			;Efface le contenu du graph buffer.
 ld hl,PLOTSSCREEN+(8*12)		;Adresse du graph buffer associe au dbut de la
								;huitime ligne de l'cran en partant du haut.
 ld de,7*12			;Espacement des lignes (en nombre d'octets dans le graph buffer).
 ld b,6				;Nombre de lignes.
 ld a,%11101110		;Aspect de l'octet  copier. (On fait des pointills).
lignes:
 add hl,de			;L'ajout de 7*12 permet de passer  la ligne suivante. NOTE :
					;la premire ligne dessine n'est donc pas la huitime de l'cran,
					;mais la seizime.
horiztrace:			;Routine de trace d'une ligne ( motif stock dans a) horizontale.
 ld c,12			;Nombre d'octets  copier dans le graph buffer pour obtenir une ligne.
horizboucle:
 ld (hl),a			;Copie l'octet du motif  l'adresse contenue dans hl.
 inc hl				;Passe  l'adresse suivante du graph buffer.
 dec c				;Un octet ayant t copi, on dcrmente c en consquence.
 jr nz,horizboucle	;Si c est diffrent de zro, passe  la trace de l'octet suivant. 
 djnz lignes		;Si c = 0 et b est diffrent de zro, passe  la trace de la ligne
					;suivante. Sinon, passe  la copie du logo MYP dans la marge droite.

;Affichage du logo myp.

loadbouclemyp:				;Prparation de la boucle de copie du logo MYP.
 ld hl,PLOTSSCREEN+178		;Place hl  l'adresse adquate du graph buffer.
 ld b,6						;Rgle le nombre d'itrations de la boucle djnz  6, car on copie
							;6 fois le logo MYP par colonne.
bouclemyp:					;Boucle de copie du logo MYP.
 push bc					;Sauvegarde b dans la pile, car on a besoin de bc pour la
							;routine affsprite.
 ld de,3*12					;Rgle l'intervalle de copie  trois lignes de l'cran.
 add hl,de					;Place hl  l'adresse de copie du logo MYP. Le premier est
							;donc copi  l'adresse PLOTSSCREEN+178+3*12 = PLOTSSCREEN+214 ou
							;PLOTSSCREEN+179+3*12 = PLOTSSCREEN+215 selon la colonne de logos
							;MYP traite.
 ld de,myp					;Charge l'adresse du premier octet du logo MYP dans de.
 ld bc,$0501				;Charge 5 dans b et 1 dans c afin d'indiquer  la routine
							;affsprite que le logo MYP fait 1 octet de long pour 5 de haut.
 call affsprite				;Appelle la routine affsprite afin d'afficher le logo MYP.
 pop bc						;Rcupre la valeur de b.
 djnz bouclemyp				;Relance le processus de copie du logo MYP tant que b est diffrent
							;de zro.
 ld de,PLOTSSCREEN+214+540	;
	icall(_cphlde)			;Teste si hl = PLOTSSCREEN+214+540.
 ret nz						;Si non, cela signifie que les deux colonnes de logos MYP ont t
							;affiches. En ce cas, retourne  l'adresse suivant call lignemenu.
 ld hl,PLOTSSCREEN+179		;Si hl = de, alors il faut crer la seconde colonne de logos MYP.
							;hl est donc regl de faon adquate.
 ld b,6						;Rgle le nombre d'itrations de la boucle djnz  6, car on copie
							;6 fois le logo MYP par colonne.
 jr bouclemyp				;Va tracer la seconde colonne.

;Enoncs du menu principal.

menu1:
 ld hl,$0600		;Charge $0600 dans de.
 ld (pencol),hl		;Charge 6 dans (penrow) et 0 dans (pencol).
 ld hl,tTitle		;Charge l'adresse mmoire d'alias "tTitle" dans hl.
	bcall(_vputs)	;Affiche le texte plac  l'adresse contenue dans hl aux
					;coordonnes (pencol)=>x=>colonne et (penrow)=>y=>ligne.
					;Cette commande affiche du texte en minuscules.
 ld a,$31			;Charge le code du caractre "1" dans a.
 ld bc,$0202		;Charge b et c en vue des itrations ncessaires (voir les
					;commandes "djnz bouclej" et "jr nz,bouclej" qui suivent).
 ld hl,$0800		;Charge hl afin d'obtenir hl = $1000 aprs "add hl,de".
bouclej:			;Boucle d'criture de "1 joueur" ou "2 joueur" (on rajoute
					;les "s" aprs) dans le menu. Ces expressions apparaissent
					;dans quatre lignes conscutives de faon alterne. On
					;effectue l'criture en utilisant quatre fois la mme
					;boucle, mais en changeant des valeurs selon les besoins.
 ld de,$0800		;
 add hl,de			;Addition  effectuer pour faire passer penrow  la ligne
					;suivante du menu.
 push hl			;Sauvegarde hl  cause de la routine _vputmap qui l'utilise.
 ld (pencol),hl		;Dfinit penrow et pencol en fonction de hl.
	bcall(_vputmap)	;Affiche "1" ou "2" selon la valeur de a.
 ld hl,dispjoueur	;Charge l'adresse  laquelle se trouve " joueur" dans hl.
	bcall(_vputs)	;Affiche " joueur"  l'endroit dsign par penrow et pencol.
					;dans le graph buffer et  l'cran.
 push bc
testbesoins:
 dec b
 jr nz,pasdes
 ld a,$73			;Charge le caractre "s" dans a.
	bcall(_vputmap)	;Affiche "s"  l'cran et copie le code associ dans le
					;graph buffer.
pasdes:
 dec c
 jr z,pasanonymeoupasdes
 ld a,$20
	bcall(_vputmap)
	bcall(_vputs)
 inc b
 jr testbesoins
pasanonymeoupasdes:
 pop bc

 
 pop hl				;Rcupre la valeur de hl ncessaire pour la dfinition
					;des nouvelles valeurs de penrow et pencol.
 ld a,$32			;Charge le code du caractre "2" dans a.
 djnz bouclej		;Premier renvoi
 dec a				;Recharge dans a le code du caractre "1".
 ld b,2				;On veut effectuer la boucle djnz deux fois.
 dec c				;Equivalent d'une boucle djnz, mais avec c, car b est dj
 jr nz,bouclej		;utilis dans l'autre boucle djnz. Ca prend un octet de plus.
					;Elle permet de refaire la boucle djnz prcdente.
 ld de,$3000		;Charge la valeur (penrow-col) du dbut de la cinquime ligne
					;dans de. 
 ld hl,dispaide		;Charge l'adresse de "Aide" dans hl.
 ld (pencol),de		;Charge la valeur contenue dans de dans penrow-col.
	bcall(_vputs)	;Affiche "Aide" et copie le code associ dans le graph buffer.
 ld d,$38			;Prpare le passage  la ligne suivante.
 ld (pencol),de		;Passe  la ligne suivante.
#ifdef TI83P
	bcall(_vputs)	;On affiche "Sortie" car hl = dispexit du fait de l'utilisation
					;prcdente de _vputs (en effet, dispexit suit le "0" plac
					;aprs "Aide"). 
 ret				;On retourne  l'endroit d'o a t appel "menu1:" (voir
					;"call menu1").
#else
 jp _vputs			;Le "ret" contenu dans la routine _vputs sert  revenir 
					;l'adresse d'o a t appel "menu1:". Ceci n'est pas possible
					;sur TI 83+, d'o la diffrenciation.
#endif
;Stockage de certains textes en ASCII (remplacement des lettres
;par leur code effectu par le compilateur).
dispnom:
 .db "Nom"				;L'absence de zro suivant "Nom" implique que vputs
						;n'affichera pas uniquement "Nom", mais "Nom du joueur".
dispdu:					;Cependant, comme on est amen  afficher " du joueur" et
 .db " du"				;" joueur" seuls, on prfrera le rdiger ainsi pour
						;faciliter la localisation de chaque morceau au moyen de
dispjoueur:				;labels et simplifier la comprhension du code.
 .db " joueur",0

dispanonyme:
 .db "anonyme",0

dispaide:
 .db "Aide",0

dispexit:
 .db "Sortie",0

;Redirection selon touche presse.

getkey1: 
 call ionfastcopy			;Appel de la routine d'affichage de l'cran afin
							;de porter  l'cran ce qui est contenu dans le
							;graph buffer (les lignes du menu, les divers
							;textes...).

 res TextWrite,(iy+SGrFlags)	;Dsactive la sauvegarde du texte crit en
								;minuscules  l'aide des routines _vputs,
								;_vputmap... dans le graph buffer. Ainsi, le
								;texte sera simplement affich  l'cran sans
								;laisser de traces dans le graph buffer.

;Affichage du curseur de slection.

 ld hl,$104A		;Configure (penrow-col) afin d'afficher le curseur en face
 ld (pencol),hl		;de la premire ligne.
 ld a,$CF			;Charge le code d'un caractre ressemblant  "<" (le curseur) dans a.
	bcall(_vputmap)	;Affiche le caractre dont le code est contenu dans a,
					;mais ne sauvegarde pas cette modification dans le graph buffer.

getkey:				;Boucle d'obtention d'un code de touche presse par l'utilisateur.
 ex de,hl			;Sauvegarde hl, car il est dtruit par introwaitkey2.
 call introwaitkey2	;Attend la pression d'une touche, stocke le code de
					;celle-ci dans a et continue l'excution.
 ex de,hl			;Rcupre la valeur de hl.
 cp $04				;Compare le code de la touche flche pointant vers le haut  a.
 jr z,haut			;Si a contient le code de la touche susdite, va au label haut.
 cp $01				;Compare le code de la touche flche pointant vers le bas  a.
 jr z,bas			;Si a contient le code de la touche susdite, va au label bas.
 cp $36				;Compare le code de la touche 2nd  a.
 ret z				;Si a contient le code de la touche susdite, on retourne 
					;l'adresse suivant celle d'o a t appel "getkey1:", car "2nd" est
					;la touche traditionnelle de validation dans les programmes asm.
 jr getkey			;Si aucun des tests n'est positif, retourne  "getkey:" afin d'obtenir
					;un nouveau code de touche.

;Effaage du curseur prcdent et affichage du nouveau  la ligne du dessus
;(ou  la dernire ligne si on se trouve  la premire).

haut:
 ld a,l				;l vaut $4A.
 ld (pencol),a		;Charge $4A dans pencol, car _vputmap a fait changer (pencol).
 ld a,$06			;Charge le code du caractre " " dans a.
	bcall(_vputmap)	;"efface" le curseur prcdent.
 ld a,(penrow)		;Prpare les comparaisons de (penrow)  des valeurs particulires.
 cp 16				;Regarde si le curseur est  la position la plus haute.
 jr z,haut02		;Si oui, renvoie au label haut02.
 sub 8				;Soustrait 8  a.
 ld h,a				;Charge (penrow) dans h.
 ld (pencol),hl		;Charge la nouvelle valeur dans (penrow) et $4A dans (pencol).
					;(penrow) est mis  jour (on veut monter d'une ligne). Pour cela, on
					;dcrmente de 8, car l'origine de penrow est lie  la ligne suprieure
					;de l'cran, il faut donc dcrmenter pour monter. Or, chaque caractre
					;minuscule fait 7 pixels de hauteur.
 ld a,$CF			;Charge le code d'un caractre ressemblant  "<" (le curseur) dans a.
	bcall(_vputmap)	;Affiche le curseur  sa nouvelle position.
 jr getkey			;Retourne  la boucle principale d'obtention d'un code de touche presse
					;par l'utilisateur.

haut02:			;Ce code (ce qui suit jusqu' "jr getkey") place le curseur en bas.
 ld h,56			;Charge la valeur qu'il faut donner  (penrow) pour aller  la dernire
					;ligne.
 ld (pencol),hl		;Met  jour (penrow-col), l valant toujours $4A.
 ld a,$CF			;Charge le code d'un caractre ressemblant  "<" (le curseur) dans a.
	bcall(_vputmap)	;Affiche le curseur  sa nouvelle position.
getkeybis:
 jr getkey			;Retourne  la boucle principale d'obtention d'un code de touche presse
					;par l'utilisateur.

;Effaage du curseur prcdent et affichage du nouveau  la ligne du dessous
;(ou  la premire ligne si on se trouve  la dernire).

bas:
 ld a,l				;Prpare la mise  jour de (pencol) qui a t modifi par _vputmap.
 ld (pencol),a		;Replace (penrow-col)  l'endroit o le curseur est actuellement affich.
 ld a,$06			;Charge le code associ  " " dans a.
	bcall(_vputmap)	;"Efface" le curseur en le remplaant par un espace.
 ld a,(penrow)		;Charge la valeur de (penrow) correspondant  la dernire ligne du menu
					;dans a afin de la comparer avec la valeur (penrow).
 cp 56				;Regarde si le curseur est  la position la plus basse (penrow = 56 ?).
 jr z,bas07			;Si oui, renvoie au label "bas07:".
 add a,8			;Ajoute 8  a.
 ld h,a				;Prpare la mise  jour de (penrow)
 ld (pencol),hl		;Met  jour (penrow) et rtablit (pencol).
 ld a,$CF			;Charge le code d'un caractre ressemblant  "<" (le curseur) dans a.
	bcall(_vputmap)	;Affiche la nouvelle position du curseur.
 jr getkey			;Retourne  la boucle principale d'obtention d'un code de touche presse
					;par l'utilisateur.

bas07:			;Ce code (ce qui suit jusqu' "jr getkey" place le curseur en haut).
 ld h,$10			;Charge dans h la valeur  donner  (penrow) pour afficher le curseur
					; la premire ligne du menu.
 ld (pencol),hl		;(penrow) = $10 et (pencol) = $4A.
 ld a,$CF			;Charge le code d'un caractre ressemblant  "<" (le curseur) dans a.
	bcall(_vputmap)	;Affiche la nouvelle position du curseur.
 jr getkeybis		;Retourne  la boucle principale d'obtention d'un code de touche presse
					;par l'utilisateur.


;Copie de "ordinateur" dans l'emplacement ddi au nom du joueur 2.

jrnomj2:				;ATTENTION : ne pas utiliser le flag z jusqu' ret
 ld de,nomj2+1			;(explication  "jeurapide:") !
 ld hl,dispcomputer		;Prpare la copie de "ordinateur",0  l'adresse nomj2+1.
 ld bc,$000B			;$000B = 11, car "ordinateur",0 fait 11 caractres.
 ldir					;Cette commande effectue la copie de (hl) dans (de), incrmente
						;hl et de, dcrmente bc et recommence jusqu' ce que bc = 0.
 ret					;On va  la ligne suivant "call enter".

;Affichage de l'cran d'aide.

aide:
 ld de,picaide			;Copie dans de l'adresse du dbut des donnes de l'image 
						;dcompresser.
 call LVRLE				;Appelle la routine de dcompression Vertical RLE afin de dcompresser
						;l'image dans le graph buffer.
 call ionFastCopy		;Copie le contenu du graph buffer  l'cran grce  une routine incluse
						;dans ION.
 call introwaitkey2		;Attend que l'utilisateur frappe une touche, quelle qu'elle soit.
 pop de					;Enlve l'adresse que le "call enter" a laiss dans la pile.
 jp retouraide			;Retourne  la partie du code qui affiche le menu initial.



;Prise en compte de la slection effectue par l'utilisateur.

enter:
 ld a,(penrow)		;C'est en fonction de la valeur de (penrow) au moment de la slection du
 ld (modejeux),a	;mode de jeu que l'on dfinit ce dernier.
 cp 48				;Regarde si c'est la visualisation de l'cran d'aide qui est choisie.
 jr z,aide			;Si oui, va au label aide.
 ret p				;Regarde si c'est la sortie qui est choisie.
 cp 25				;Si (modejeux) - 25 < 0, alors, (modejeux) = 16 ou 24. Dans ce cas,
 jp m,jeurapide		;l'utilisateur saute la partie du code o l'on entre le nom du joueur.
 					;Sinon, (modejeux) = 32 ou 40, cela signifie que l'itilisateur doit
 					;entrer respectivement un ou deux noms de joueurs.

;Entre du nom du joueur 1.

 ld a,$31		;Charge le code du caractre "1" dans a.
 ld de,nomj1	;Charge l'adresse de nomj1 (variable dans laquelle on stocke le nom du
				;joueur 1) dans de.
 call nomjoueur	;Partie du code qui,  partir de a et de, affiche "Nom du joueur
				;[caractre dont le code est contenu dans a]:", puis saute  la routine
				;inputxt afin de permettre  l'utilisateur de rentrer un nom de 10 lettres
				;maximum qui sera enregistr dans la variable dont l'adresse est stocke
				;dans de.

 ld a,(modejeux)	;
 cp 32				;Regarde si on se trouve dans le mode 1 joueur (avec entre du nom).
 jr z,jrnomj2		;Si oui, on passe  la partie du code qui copie "ordinateur" dans nomj2.
					;Sinon, on prpare l'entre par l'utilisateur du nom du joueur 2.

;Entre du nom du joueur 2.

 ld a,$32			;Charge le code du caractre "2" dans a.
 ld de,nomj2		;Charge l'adresse de nomj2 (variable dans laquelle on stocke le nom du
					;joueur 2) dans de.

nomjoueur:
 push de			;Sauvegarde de dans la pile, car _clrlcdf dtruit son contenu.
	bcall(_clrlcdf)	;Efface l'cran.
 ld hl,$0000		;
 ld (pencol),hl		;Remet penrow-col en haut  gauche.
 ld hl,dispnom		;Charge dans hl l'adresse de "Nom du joueur".
	bcall(_vputs)	;Affiche "Nom du joueur" en haut  gauche.
 ld (pencol),a		;Charge la valeur du caractre "1" ou "2" selon la valeur de a dans
					;(pencol), car il se trouve que par un hasard surprenant, a valant
					;49 ou 50 ($31 ou $32), on peut s'en servir pour crer un espace entre
					;"joueur" et "1" ou "2". Simplement, l'espace est plus grand lorsque
					;l'on affiche 2, car (pencol) vaut alors 50 et non 49 qui est la valeur
					;idale pour obtenir un espace quivalent  l'affichage du caractre " "
					;entre "joueur" et "1". On a donc "  " entre "joueur" et "2". C'est une
					;optimisation tire par les cheveux qui fait gagner quelques octets.
					;Evidemment, on peut aussi ne pas mettre d'espace...:)
	bcall(_vputmap)	;Affichage de "1" ou "2" selon le cas.
 ld a,$3A			;Charge le code du caractre ":" dans a. L, je ne mets pas d'espace, car
					;je trouve que a passe mieux.
	bcall(_vputmap)	;Affiche de ":".
 pop de				;Rcupre la valeur de de prcdemment sauvegarde dans la pile.
 ld hl,$0002		;Place le curseur des grandes lettres au dbut de la deuxime
 ld (currow),hl		;ligne ( partir du haut).


;
;
;Debut routine inputxt.
;
;

;entre de : adresse RAM o doit dbuter l'enregistrement du texte.
;on enregistre $00 dans la premire case mmoire et dans la dernire.
;il faut donc prvoir deux adresses en plus.
;entres curcol et currow
;entre c : nombre de caractres MAX compris dans ]0;16]
;Registres dtruits : de, hl, bc, af.
;Valeurs de sortie :
;a = 0
;f = %01?0?000
;b = ?
;c = nombre de lettres MAX - nombre de lettres rel.
;de = adresse du dernier zro.
;h = ? (getcsc...)
;l = code getcsc de dernire touche appuye.

inputxt:
 ld c,10			;Chargement du nombre de caractres maximal de la chane de caractres.
 xor a				;Met le contenu de l'accumulateur  zro.
itxtnodel1:
 ld (de),a			;Cre le repre de dbut de ligne (c'est--dire, un zro).
itxtnodel:
 inc de				;Passe  l'adresse suivante.
itxtcapture:
 xor a				;Met le contenu de l'accumulateur  zro.
 ld (de),a			;Copie de zro  l'adresse indique par de.
 push bc			;Ajout  la routine initiale pour utiliser introwaitkey2  la place de waitkey.
 call introwaitkey2	;Retourne le code de la touche presse dans l'accumulateur.
 pop bc				;Voir deux lignes plus haut.
 ld l,a				;Sauvegarde le code touche obtenu.
 sub $36			;Compare ce dernier  celui correspondant  la touche "2nd".
 ret z				;Si bouton "2nd" press, fin de routine.
 sub $38-$36		;Comparaison avec le code li  la touche "DEL".
 jr z,itxtdel		;Si la touche presse est bien "DEL", va au label correcpondant.
 xor a				;Met le contenu de l'accumulateur  zro.
 cp c				;Regarde si le nombre de caractres maximum spcifi est atteint.
 jr z,itxtcapture+1	;Si c'est le cas, saute au label idoine.

itxtdetermination:	;Sinon, on analyse le code de la touche renvoy par la routine waitkey.
 ld h,a				;Met h  zro.
 ld b,a				;Met b  zro.
 ld a,$21			;Charge le code (getcsc) de la touche 0 lie  l'espace.
 sub l				;Compare ce code  celui entr par l'utilisateur (et soustrait le contenu de l  a).
 jr z,itxtcodelettre;Si cela correspond, va au label itxtcodelettre (ce caractre n'est pas intgr  la boucle de dtection).
 ld l,5				;Prpare une boucle  venir.
 sub 17				;Prpare une comparaison  venir.
 call itxtadd31		;Appelle la fonction de comparaison (note : b = 0).
 sub 16				;Prpare une comparaison  venir.
itxtboucle:			;Dbut de la boucle de comparaison.
 ld b,2				;Charge la valeur ncessaire  la boucle djnz incluse dans itxtadd31.
 call itxtadd31		;Appelle la fonction de comparaison (note : b = 2).
 jr nz,itxtboucle	;Relance la comparaison.
 push af			;Met une valeur dans la pile, car le "ret p" qu'on trouve
					;plus loin ne sera pas utilis, mais le "pop af" sera lui excut.
 
itxtadd31:			;Dbut de la fonction de comparaisons successives.
 inc h					;v
 add a,31				;v
 jr z,itxtcodelettrepop ;v
itxtsub08b:				;v
 inc b					;v
 inc b					;v
itxtsub08:				;v
 inc h					;v
 sub 8					;v
 jr z,itxtcodelettrepop	;v
 djnz itxtsub08			;v
 dec l					;Mieux vaut voir le fonctionnement global de la
 ret p					;routine pour comprendre cette partie. Voir si ticalc.org.

itxtcodelettrepop:
 pop af					;Sert  sortir de la pile l'adresse mise par "call itxtadd31",
 inc l					;car celle-ci n'a pas t sortie par le "ret p".
 jr z,itxtcapture		;Signifie que la touche presse par l'utilisateur n'tait pas une lettre.

itxtcodelettre:
 ld a,h					;Charge dans a un code relatif au nombre d'itrations de la boucle de dtection.
 or a					;Le compare  zro.
 ld a,$20				;
 jr z,itxtcopie			;Si h vaut zro, alors, le caractre  copier est un espace.
 rla					;ld a,$40, valeur  ajouter  h pour obtenir le code du caractre  copier.
 add a,h				;Production du code (voir character map) du caractre  copier.
itxtcopie:
 dec c					;Dcrmente le nombre de caractres maximum que l'on peut encore crire.
#IFDEF TI82
	ROM_CALL(TR_CHARPUT);Appel de la Rom_call de la TI82 qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#else
	bcall(_putmap)		;Appel de la Rom_call de la TI83(+) qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#endif
 ld hl,curcol			;
 inc (hl)				;Met  jour les variables currow et curcol.
 jr itxtnodel1			;Saute  la copie du caractre dans la mmoire et  la suite de la routine.

itxtdel:		;On compare la valeur de l'octet prcdent
 ld (de),a				;Copie zro (symbole de fin de la chane de caractres)  l'adresse pointe par de.
 dec de					;Fait pointer de vers l'adresse prcdente.
 ld a,(de)				;
 or a					;Compare la valeur de la donne qui est stoche  l'adresse susdite avec zro.
 jr z,itxtnodel			;S'il s'agit d'un zro, c'est que l'on se trouve au dbut de la chane de caractres, on ne met donc pas 
						;jour c et on incrmente  nouveau de.
 xor a					;
 ld (de),a				;Sinon, on supprime l'octet point par de.
 ld hl,curcol			;
 dec (hl)				;Dcrmente curcol afin de prparer la copie d'un espace  la place du caractre antrieur.
 ld a,$20				;Charge le code relatif  l'espace dans l'accumulateur.
#IFDEF TI82
	ROM_CALL(TR_CHARPUT);Appel de la Rom_call de la TI82 qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#else
	bcall(_putmap)		;Appel de la Rom_call de la TI83(+) qui affiche le caractre dont le code est contenu dans a en grandes lettres.
#endif
 inc c					;Met  jour le compteur du nombre maximum de caractres restants.
 jr itxtcapture			;On retourne au dbut de la routine.

;
;
;Fin de routine inputxt.
;
;

;Affichage du menu de choix de mode de jeu pour les modes anonymes.

jeurapide:
 cp 16				;Compare (modejeux) stock dans a  16 pour voir si on est
					;dans le mode 1 joueur anonyme. 
 call z,jrnomj2		;Si oui, copie 0,"ordinateur",0 dans l'endroit ddi au nom
					;du joueur 2. IMPORTANT : entre le label "jrnomj2:" et le
					;"ret" qui permet de passer  "call nz,j2dansj2", il n'y a
					;aucune commande affectant le flag z. Ainsi, on est sr
					;qu'un seul des deux "call" sera execut.
 call nz,j2dansj2	;Sinon, on copie 0,"joueur 2",0 dans nomj2.

;Prparation  la copie de "joueur 1" dans nomj1.

 ld de,nomj1+1		;Prpare la copie de "joueur 1",0  l'adresse nomj1+1.
 ld a,$31			;Charge le code du caractre "1" dans a.

;Copie de "joueur 1" dans l'endroit ddi au nom du joueur 1...:)

 jr jdansj

;Copie de "joueur 2" dans l'endroit ddi au nom du joueur 2...;)

j2dansj2:
 ld de,nomj2+1		;A l'emplacement nomj2 devrait se trouver un zro si on
					;utilisait la routine inputxt.
 ld a,$32			;Charge le code du caractre "2" dans a.
jdansj:
 ld hl,dispjoueur+1	;Au label "dispjoueur:", on trouve un espace ($20), c'est
					;pourquoi on charge l'adresse dispjoueur+1 dans hl.
 ld bc,$0006		;"joueur" fait 6 lettres.
 ldir				;Copie de "joueur"  l'adresse nomj1+1 ou nomj2+1 selon le cas.
 ex de,hl			;Copie de dans hl, ainsi hl contient l'adresse qui suit directement
					;"joueur", donc nomj1+7 ou nomj2+7 selon le cas.
 ld (hl),$20		;Ecrit un espace aprs "joueur", car $20 est le code de " ".
 inc hl				;hl = nomj1+8 ou nomj2+8 selon le cas.
 ld (hl),a			;On copie "1" ou "2" selon le cas aprs "joueur ".
 inc hl				;hl = nomj1+9 ou nomj2+9 selon le cas.
 ld (hl),c			;Charge 0  l'adresse contenue dans hl pour obtenir un
					;enregistrement conpatible avec les routines _vputs et _vputmap.
 ret				;Retourne  l'adresse suivant l'instruction "call enter".


enonce21:
 .db "Nombre de "

disptirs:
 .db "tirs",0

enonce22:
 .db " par",0

dispbuts:
 .db "Buts:",0

;Enoncs du menu permettant de choisir le nombre de tirs.

nbretirs:
 ld de,$0800		;Prpare le chargement de penrow-col. On utilise de, car hl est
					;utilis pour indiquer l'adresse du texte  afficher.
 ld (pencol),de		;Charge penrow-col  l'endroit de l'cran o l'on veut afficher
					;"Nombre de tirs par joueur :".
 ld hl,enonce21		;Charge l'adresse de "Nombre de tirs" dans hl.
	bcall(_vputs)	;Affiche "Nombre de tirs" aux coordonnes penrow-col.
	bcall(_vputs)	;Affiche " par"  la suite.
 ld hl,dispjoueur	;Charge l'adresse de " joueur" dans hl.
 	bcall(_vputs)	;Affiche " joueur"  la suite.
 ld a,$3A			;Charge le code du caractre ":" dans a.
 	bcall(_vputmap)	;Affiche le caractre dont le code est stock dans a  la suite de joueur.
 di					;On dsactive les interruptions, afin d'utiliser les registres fantmes.
 ld (pencol),a		;Du fait de l'utilisation de _vputmap, a vaut zro.
 ld bc,$0605		;Charge le nombre d'itrations de la boucle [djnz - bouclenbre] (6 fois pour
					;6 lignes) et le nombre que l'on additionnera  a pour obtenir le nombre
					;de tirs proposs  l'utilisateur selon la ligne o l'on se trouve (5, 10,
					;15, 20, 25, 30).

bouclenbre:			;Affichage des nombres de tirs proposs  l'utilisateur.
 add a,c			;Calcule le prochain nombre de tirs proposs  l'utilisateur  afficher.
 ld h,a				;Sauvegarde le nombre de tirs proposs  l'utilisateur dans h.
#ifdef TI83			;Il semble que sur TI 83 _setxxop1 ou _dispop1a utilisent les interruptions ou
 push hl			;les registres fantmes d'o l'impossibilit de se servir de exx pour conserver
 push bc			;le contenu de bc et hl.
#else
 exx				;Echange bc, de et hl respectivement avec bc', de' et hl' afin de sauver
					;les contenus de bc et hl.
#endif
 ld hl,penrow		;Charge l'adresse de penrow dans hl.
 ld b,8				;Prpare l'ajout de 8  (penrow) afin de passer  la ligne suivante.
lignesuiv:
 inc (hl)				;Incrmente (penrow).
 djnz lignesuiv			;Permet d'incrmenter (penrow) de huit.
 	bcall(_setxxop1)	;Charge a dans OP1.
	bcall(_dispop1a)	;Affiche OP1  l'endroit dfini par penrow-col. A ce moment, la valeur
						;minimale de a est 5, donc il n'est pas ncessaire de dfinir le nombre
						;de chiffres que l'on veut afficher au maximum (ce qui se fait  l'aide
						;de a dans la routine _dispop1a.
#ifdef TI83
 pop bc
 pop hl
#else
 exx				;Permet de rcuprer bc et hl (utiliss par la boucle [djnz - lignesuiv] et
					;surtout dtruits par _setxxop1 ou _dispop1a.
#endif
 ld a,h				;Rcupre le nombre de tirs proposs  l'utilisateur dans a.
 djnz bouclenbre	;Relance la partie du code qui affiche le nombre de tirs proposs 
					;l'utilisateur selon la ligne du menu  laquelle il se trouve.
 ret				;Va  l'adresse suivant call nbretirs.

;Permet au joueur de tirer au but (tout en vrifiant qu'il ne s'est pas
;tromp de touche et en gnrant un nombre alatoire dans c.

getkeytir:
 ld b,3					;Charge dans b la limite suprieure non incluse du nombre alatoire gnr
						;par waitkey2. C'est 3, car cela permet d'avoir trois valeurs possibles
						;pour le nombre aleatoire (0, 1 ou 2) correspondant aux trois possibilits
						;pour le gardien si celui-ci est gr par l'ordinateur.
 call waitkey2			;Saute  la routine de getkey (qui gnre un nombre alatoire).
 ld (tir),a				;Charge le code de touche obtenu dans la variable (tir).
 ld d,a					;Charge le code de touche dans d, car a est utilis.
 ld a,$1D-1				;Charge dans a le code de la touche "(" ($1D) moins 1 car a est incrment
						;avant d'tre compar  d dans la boucle [djnz - testgetkeytir] qui suit.
testgetkeytir:			;La boucle [djnz - testgetkeytir] permet de tester si la touche active par
						;l'utilisateur correspond  l'une des touches attendues.
 inc a					;Incrmente a pour obtenir le code touche que l'on souhaite tester.
 cp d					;Compare le code touche activ par l'utilisateur (compris dans d)  un code
						;touche particulier (compris dans a).
 ret z					;Si le code de la touche active par l'utilisateur correspond  l'un des codes
						;associs aux touches prvues pour tirer, va  l'adresse suivant "call getkeytir".
 djnz testgetkeytir		;Par chance, la valeur initiale de b, 3, correspond aux nombres d'itrations
						;dsir pour la boucle djnz, car on teste trois touches d'une mme colonnes.
						;Exemple : lors de la premire utilisation de la boucle, on teste successivement
						;les touches "(" ($1D), "cos" ($1E) et "prgm" ($1F).
 jp p,getkeytir			;Si la touche a un code infrieur  celui test, on recommence la saisie, car
						;cela signifie que la touche active par l'utilisateur n'est pas prvue pour tirer.
						;Evidemment, cela implique de commencer par tester les touches dont le code est
						;le plus "petit" (numriquement) parmi celles prvues pour tirer et de continuer ces
						;tests par ordre croissant.
 cp $2F					;Compare a au code de la touche suivant "x-1" ("math"), "x-1" tant la dernire teste. Ainsi,
 jr z,getkeytir			;si la touche active par l'utilisateur possde un code suprieur  celui de "math", il
						;doit recommencer.

 add a,5				;Sinon, on incrmente a de 5 afin de refaire une srie de tests. Cela permet de passer
						;d'une colonne  l'autre en tenant compte de l'incrmentation de a. Exemple : $1F (= "prgm")
						;+ 5 + 1 = $25 = ",".
 ld b,3					;Recharge le nombre d'itrations de la boucle [djnz - testgetkeytir].
 jr testgetkeytir		;Va au dbut de la boucle [djnz - testgetkeytir].

;Dtermination du choix du gardien (ordinateur).

suite:				;c contient le nombre aleatoire gnr par waitkey2.
 ld b,c				;Charge le nombre alatoire dans b afin d'utiliser djnz.
 inc b				;Incrmente b, car c vaut 0, 1 ou 2 alors qu'il faut que b soit
					;gal  1, 2 ou 3 puisque "djnz" dcrmente avant de tester si b = 0.
 ld a,$20-8			;Charge dans a une valeur gale au code de la touche "stat" auquel on a
					;soustrait 8, car la boucle [djnz - suitedjnz] incrmente a avant d'executer "djnz".
suitedjnz:
 add a,8			;Cette addition permet de donner  a la valeur de l'un des codes des touches utilises
					;pour choisir l'endroit o l'on souhaite que le gardien plonge.
 djnz suitedjnz		;Selon la valeur de b, dtermine "alatoirement", on affecte le code d'une touche
					;au choix du gardien gr par l'ordinateur. Le fait de transcrire le choix de l'ordinateur
					;sous cette forme permet d'utiliser la mme partie du code pour calculer le rsultat et
					;raliser l'animation que s'il s'agissait de l'entre d'un utilisateur.
 ld (stoppe),a		;Sauvegarde le code touche affect au choix de l'ordinateur dans la variable idoine.
animationbis:
 jp animation		;Va  "animation:".

dispstoppe:
 .db " stoppe",0

disptire:
 .db " frappe",0

dispcomputer:
 .db "ORDINATEUR",0

;Permet au joueur de contrler le gardien.

getkeyarret:
 call introwaitkey2	;Appelle la routine de getkey (qui gnre un nombre alatoire compris entre 0 et 8
					;inclus).
 ld (stoppe),a		;Charge le code de touche obtenu dans la variable (stoppe).
 ld b,3				;Ce nombre d'itrations de la boucle [djnz - verif] correspond au nombre de touches
					;possibles pour commander le gardien.
verif:				;Vrifie que la touche presse est bien l'une des touches associes au gardien.
 cp $30				;$30 est le code de la touche "alpha".
 ret z				;Si a = $30, alors (stoppe) possde une valeur correcte, donc l'execution se
					;poursuit  l'adresse suivant "call getkeyarret".
 add a,8			;Ajoute 8  a, car le code de la touche "x,t,,n" est $28, c'est--dire $30-8
					;et le code de la touche "stat" est $20, c'est--dire $1E-8-8.
 djnz verif			;Permet d'effectuer trois comparaisons.
 jr getkeyarret		;Permet  l'utilisateur de valider une autre touche s'il s'est tromp.

;Dtermination du choix du tireur (ordinateur).

suite2:
 ld a,$1D-1			;Prpare la boucle d'affectation d'un code tir  l'ordinateur ($1D est le code de 5).
 inc c				;Ainsi, c est diffrent de 0 avant dec c. Rappel : c a une valeur aleatoire comprise
					;entre 0 et 8. Donc, maintenant, entre 1 et 9.
initboucleaffectir:
 ld b,3				;Initialise le nombre d'itrations de la boucle [djnz - boucleaffectir]. On en fait trois,
					;car les codes touche associs au tir se classent en trois groupes de codes qui se
					;suivent ($1D $1E $1F ; $25 $26 $27 ; $2D $2E $2F).
boucleaffectir:		;Cette boucle permet d'affecter un code touche de tir.
 inc a					;Passe au code touche suivant.
 ld (tir),a				;Charge ce code touche dans la variable de tir.
 dec c					;Dcrmente c.
 jr z,animationbis		;Ds lors que c vaut 0, on arrte la boucle.
 djnz boucleaffectir	;Retourne  "boucleaffectir:" si b est diffrent de 0.
 add a,5				;Ajoute 5  a pour passer  un autre groupe de codes touche.
 jr initboucleaffectir	;Relance la boucle d'affectation d'un code touche de tir.

;Textes  afficher en cas de but ou d'arrt.

dispgoal:
 .db " !!GOAL!!",0

disparret:
 .db "!ARRET!",0


;Sous-programme d'affichage du graphisme.

animation:
 call effjts					;Efface les inscriptions en bas de l'cran.
 ld hl,PLOTSSCREEN+(57*12+5)	;Charge l'adresse  laquelle on veut copier le ballon.
 ld de,tgballon					;Charge l'adresse o est stock le ballon.
 ld bc,$0702					;Charge la hauteur du sprite du ballon dans b et la largeur dans c.
 call affsprite					;Appelle la routine d'affichage du sprite (mode normal, pas d'effet miroir).
 call IonFastCopy				;Copie le contenu du graph buffer  l'cran.
 ld b,100						;Charge dans b la dure de la temporisation.
 call tempo						;Appelle la temporisation.
 call affcage					;Appelle la routine de copie de la cage vierge dans le graph buffer.

;Trace du ballon selon le code tir choisi.
;Pour comprendre les commentaires qui suivent, il faut comprendre que la cage est divise en 9 zones, c'est--dire,
;autant que de possibilits de tir. On a donc une sorte de matrice 3*3.

 ld a,(tir)						;Charge le code tir dans l'accumulateur.
 ld hl,PLOTSSCREEN+(24*12)+8	;Charge l'adresse du graph buffer correspondant au dbut de la zone situe
								;en haut  droite de la cage.
 ld de,-4						;Prpare le dcalage de hl de quatre octets "vers la gauche" (d'o le moins).
 sub $20						;Soustrait $20  la valeur de (tir). Ainsi, si (tir) vaut $1D, $1E ou $1F, a<0.
 ld b,2							;Prpare une boucle djnz (qui permet ici d'conomiser quelques octets).
boucledetectcol:;Dans cette partie, on considre la "colonne" dans laquelle se trouve la zone de tir choisie.
 jp m,ok1						;Si a<0, alors on saute au label ok1. Si b=2, alors, cela signifie que le tir
								;a lieu dans la "colonne" de droite. Si b=1, dans la "colonne" du milieu.
 add hl,de						;Fait passer hl d'une "colonne"  une autre vers la gauche. Il y a trois
								;"colonnes" (autant que de choix possibles pour le gardien) dans la cage.
								;Chacune fait 4 octets de largeur.
 sub $8							;Soustrait 8  a. Ainsi, on peut tester si (tir) vaut $25, $26 ou $27 et, si ce
								;n'est pas le cas, cela signifie que (tir) vaut $2D, $2E ou $2F. Dans tous les
								;cas, les soustractions successives de a permettent de donner  celui-ci une des
								;valeurs suivantes : -1, -2 ou -3. Ces valeurs vont nous permettre de dterminer
								;dans quelle zone de la cage on se trouve, car elles donnent une information sur
								;la "hauteur" de cette dernire.
 djnz boucledetectcol			;Si b est diffrent de zro, alors on refait la boucle.

ok1:;Dans cette partie, on considre la "hauteur" (suprieure, mdiane ou infrieure) de la zone de tir choisie.
 ld de,13*12					;Charge la valeur qu'il faudra ajouter  hl pour passer  la hauteur mdiane. Pour
								;le moment, hl est  la hauteur suprieure.
 ld c,13						;13 est le nombre de lignes que contient chaque zone se trouvant dans la partie
								;suprieure de la cage.
 inc a							;Incrmente a pour tester s'il valait -1 avant l'incrmentation. Si c'tait le cas,
								;cela implique que (tir) vaut $1F, $27 ou $2F.
 jr z,choixposbal				;Si c'est le cas, on saute  la routine qui choisit un octet de manire "alatoire"
								;dans la zone, afin d'y copier le ballon (ainsi, le ballon peut accder  un grand
								;nombre de positions).
 dec c							;12 est le nombre de lignes que contient chaque zone se trouvant dans la partie
								;mdiane de la cage.
 inc a							;Incrmente a pour voir s'il valait -2 avant les trois incrmentations.
								;Si c'tait le cas, cela implique que (tir) vaut $1E, $26 ou $2E.
 jr z,ok2						;Si (tir) vaut $1E, $26 ou $2E, on saute au label "ok2:", car la valeur de c correspond
								;bien au nombre de lignes des zones rattaches  ces trois valeurs. De plus, la valeur
								;de de concorde elle aussi. En effet, hl se trouve dans la partie suprieure de la cage,
								;donc il faut lui ajouter 13*12 pour qu'il pointe sur une adresse de la zone choisie pour
								;le tir (qui se trouve donc dans ce cas tre situe parmi les trois zones que l'on trouve
								; la hauteur mdiane de la cage.
 ld c,3							;3 est le nombre de lignes de la partie infrieure. C'est cohrent, car, compte tenu des
								;tests prcdents, on sait que (tir) vaut $1D, $25 ou $2D, ces trois valeurs tant
								;relies aux zones "du bas" de la cage.
 ld de,(13+12)*12				;Charge dans de la valeur qu'il faut ajouter  hl pour que l'adresse contenue dans ce
								;dernier pointe sur une adresse de la zone choisie pour le tir.

ok2:
 add hl,de						;Ajoute  hl la valeur dtermine prcdemment afin de le faire pointer sur une adresse
								;de la zone choisie pour le tir.

;Routine de choix "alatoire" de la position du ballon dans la zone.

choixposbal:
 ld a,(aleatoire)			;
 ld b,a						;Charge la valeur "alatoire" (voir routine waitkey) dans b.
 ld a,c						;Charge la valeur de c prcdemment affecte en fonction de la "hauteur"
 ld (nligzone),a			;de la zone dans a et dans la variable (nligzone).
 ld c,5						;Charge 5 dans c, car chaque ligne d'une zone fait 4 octets et hl pointe
							;initialement sur l'octet prcdant le premier de la ligne. Compte tenu de la
							;forme de la routine d'incrmentation de c ("bouclechoixposbal:"), il faut donc
							;incrmenter hl cinq fois pour que l'une des quatre positions de la ligne puisse
							;tre, si b=0, la position "finale" de hl.
 ld de,7					;Car hl est incrment quatre fois avant de passer  la ligne suivante puis
							;encore une fois. or, de est ajout  hl pour que ce dernier passe  la ligne
							;suivante (ou plus prcisment  l'octet prcdant le premier de la ligne
							;suivante).Donc 12-5=7.
 dec hl						;Car hl va tre incrment une fois avant de tester b (djnz), donc, si on veut
							;que le premier octet de la zone soit une position possible pour le ballon, on
							;doit dcrmenter hl (ainsi, si (aleatoire)=1, hl pointera sur le premier octet
							;de la zone.
;push hl					;Sauve la valeur initiale de hl qui est l'adresse de l'octet prcdant
							;le premier de la zone slectionne. Voir commentaire suivant.
 jr bouclechoixposbal-1		;Le -1 est l pour que le processeur excute l'instruction push hl
							;situe  l'adresse prcdant l'adresse correspondant au label
							;"bouclechoixposbal:".
add125:;Les instructions qui suivent servent  changer de ligne.
 add hl,de					;Effectue le changement de ligne.
 ld c,5						;Recharge cinq dans c, car si on excute cette instruction, c'est que c=0.
 dec a						;
 jr nz,bouclechoixposbal	;Teste si on est arriv  la dernire ligne de la zone. Si c'est le cas, on ne
							;relance pas la routine d'incrmentation de hl tout de suite, on le refait d'abord
							;pointer sur l'adresse initiale de hl (octet prcdant le premier de la zone). Sinon,
							;on relance la routine d'incrmentation de hl.
 ld a,(nligzone)			;Recharge le nombre de lignes accessibles dans a (puisqu'a=0).
 pop hl						;Recharge l'adresse initiale de hl.
 push hl					;Sauve  nouveau celle-ci dans la pile.
bouclechoixposbal:;Dbut de la routine d'incrmentation de hl.
 inc hl						;Action principale de la routine :).
 dec c						;Cette instruction et la suivante quivalent  un "djnz" qui fonctionnerait avec c.
 jr z,add125				;Vrifie si l'on se trouve en fin de ligne.
 djnz bouclechoixposbal		;Le nombre d'incrmentations de hl dpend de la valeur de (aleatoire).
 pop de						;Pour remettre la pile dans son tat initial.

;hl contient l'adresse du graph buffer o il faut copier le ballon.
 ld (adballon),hl			;ld (adballon),l et ld (adballon+1),h
 ld de,tpballon				;Charge dans de l'adresse du premier octet du sprite du ballon.
 ld bc,$0401				;Hauteur du ballon = 4 octets, largeur du ballon = 1 octet.
 call affsprite				;Appelle la routine d'affichage du sprite du ballon dans le graph buffer
							;(pas d'effet miroir).

;On teste s'il y a but ou non.
 ld a,(stoppe)
 ld hl,tir
 sub (hl)					;Soustrait  la variable de commande du gardien la variable de commande du tireur.
 ld b,3						;Prpare la boucle de type djnz.
bouclecalc:;Cette boucle permet de comparer a (contenant (stoppe) - (tir))  3, 2 et 1.
 cp b						;(stoppe) - (tir) - b = ?
 jr z,pasbut				;Si (stoppe) - (tir) = 1, 2 ou 3, il n'y a pas but (cette proprit est de
							; l'utilisation de touches de la mme colonne pour les tirs et arrts associs).
 djnz bouclecalc			;La boucle djnz prsente ici l'intrt de dcrmenter b  chaque itration.
;Si le pointeur d'excution se trouve aprs le djnz, cela signifie que le saut conditionnel vers "pasbut:" n'a
;pas t utilis et que les 3 comparaisons ont t faites, donc, il y a but.
 ld a,1
 ld (result),a				;Initialise la variable de rsultat en position "but".
 ld a,(stoppe)				;Charge le choix du gardien dans l'accumulateur.
 cp $28						;Compare la valeur susdite au code de l'arrt du milieu.
 jr z,butpasmilieu			;Si les deux valeurs correspondent, on sait que le gardien reste au milieu et
							;qu'il y a but  droite ou  gauche (cette dernire information tant ici
							;sans importance).
 ld de,gardiengauchemilieu	;Charge dans de le premier octet du sprite du gardien sautant  gauche  mi-hauteur.
 ld bc,$0703				;Charge dans bc la taille du sprite.
 jp m,butpasdroite			;Si (stoppe) > $28, il y a toujours but, mais le gardien plonge  droite.
; jp po,butpasgauche		;Sinon, (stoppe) < $28, donc le gardien plonge  gauche, sans sauver le but pour autant :).

butpasgauche:	;Affiche le sprite du gardien plongeant, sans succs,  gauche.
 ld hl,PLOTSSCREEN+((24+13+6)*12+1)	;Prpare la copie du sprite dans le graph buffer.
 jr jraffichage1bis					;Saute (en deux temps, pour viter un "jp")  l'affichage de l'action.

butpasmilieu:	;Affiche le sprite du gardien restant, sans succs, au milieu.
 ld hl,affichage2				;Prpare la recopie du sprite initial (le gardien reste au milieu) dans
								;le graph buffer.
 push hl						;Permet de continuer l'excution  "affichage1:" lors du prochain ret.

gardieninitial:	;Routine de copie du sprite du gardien en position initiale, debout.
 ld hl,PLOTSSCREEN+(37*12+5)	;Charge dans hl l'adresse o on veut copier la moiti gauche
								;du sprite du gardien.
gardieninitialbis:
 ld de,gardien1					;Charge dans de l'adresse o est stocke la moiti droite du
								;sprite du gardien.
 ld bc,$1301					;$13 = 19 (lignes) et $01 = 1 colonne ;).
 push hl
 push bc						;
 push de						;Affsprite dtruit hl, bc et de.
 call affsprite					;Affiche la moiti gauche du sprite du gardien.
 pop de							;
 pop bc
 pop hl							;Rcupration de de, bc et hl.
 inc hl							;Charge dans hl l'adresse o on veut copier la moiti droite du
								;sprite du gardien.
 call affspritemiroir			;Affiche la moiti droite du sprite du gardien.
 ret							;Va  l'octet suivant l'appel de la routine ou  "affichage1:" (voir
								;les deux lignes prcdant gardieninitial).


;Affichage de la premire partie de la squence graphique lorsque le gardien arrte le tir dans la zone...

pasbutdgb:;...en bas  droite ou  gauche.
 ld de,gardiengauchebas
 jr pasbutdgbm
pasbutdgm:;...au milieu  droite ou  gauche.
 ld de,gardiengauchemilieu
pasbutdgbm:
 ld a,c				;Rcupre la valeur de c sur a afin de dterminer s'il
					;s'agit de l'affichage normal ou de l'affichage  effet
					;miroir qu'il faut utiliser.
 ld bc,-36
 add hl,bc
 ld bc,$0703
 cp 20				;Si le contenu de a (anciennement de c) est suprieur  20,
 jp p,affichage1mir	;on affiche le sprite considr en utilisant l'effet miroir.
jraffichage1bis:
 jr affichage1		;Saute  l'affichage classique de l'action.

butpasdroite:	;Affiche le sprite du gardien plongeant, sans succs,  droite.
 ld hl,PLOTSSCREEN+((24+13+6)*12+10)	;Prpare la copie du sprite dans le graph buffer.
 jr affichage1mir						;Saute  l'affichage de l'action.

pasbutdgh:;Affichage du sprite du gardien en haut  gauche ou en haut  droite lors d'un arrt.
 ld de,gardiengauchehaut
 ld a,c
 ld bc,$0E03
 cp 20
 jr z,affichage1mir			;Saute  l'affichage de l'action avec effet miroir.
 jr affichage1				;Saute  l'affichage de l'action sans effet miroir.

tablesauts:	;Rpertorie les nombres qu'il faut utiliser avec le saut relatif jr z,$XX (voir 
			;sautmodif+1).
.db (pasbutdgb-sautmodif-2),(pasbutdgm-sautmodif-2),(pasbutdgh-sautmodif-2),(pasbutmilieub-sautmodif-2),(pasbutmilieum-sautmodif-2),(pasbutmilieuh-sautmodif-2),(pasbutdgb-sautmodif-2),(pasbutdgm-sautmodif-2),(pasbutdgh-sautmodif-2)	;-9

pasbut:	;Gestion de la copie du sprite du gardien lorsqu'il n'y a pas but (et mise  jour du rsultat
		;de la squence).
 xor a				;-1	;Mise  zro de l'accumulateur.
 ld (result),a		;-3	;Actualisation de la variable de rsultat en position "pas but".
 ld a,(tir)			;-3	;Charge le choix du tireur dans l'accumulateur.
 ld hl,tablesauts	;-3	;Place hl  l'adresse "tablesauts:".

 ld c,($1C-5)	;-2	;c = 23
 sub c			;-1
boucle2detectgard:
 sub 5		;-2
 ld b,$03	;-2		;Il faut que c>03, car "ldi" fait un "dec bc", donc, comme
					;bc est recharg aprs trois excutions de "ldi", il faut
					;au moins c>3 pour que le "dec bc" n'influe pas sur b. Ici,
					;c vaut 33, car cela permet d'initialiser le dcompte
					;et d'obtenir une valeur de c diffrente pour chaque cas
					;d'arrt du gardien.
boucle1detectgard:
;;;[SELF MODIFYING CODE;;;
 ld de,sautmodif+1	;-3	;Place de  l'adresse sautmodif+1 afin de prparer le "ldi".
;;;SELF MODIFYING CODE];;;
 ldi		;-1
 dec a	;-1
 ld de,(adballon)	;-3
 ex de,hl				;Echange les contenus de de et hl, car c'est ncessaire si
						;on saute  l'un des labels s'intitulant "pasbut...". En
						;effet, la valeur actuelle de de doit alors se trouver dans
						;hl pour utiliser la ROM_CALL cphlde.
sautmodif:
;;;[SELF MODIFYING CODE;;;
 jr z,pasbutmilieum		;L'oprande est modifi selon les besoins par la commande "ld de,sautmodif+1".
;;;SELF MODIFYING CODE];;;
 ex de,hl				;Remise en place des contenus respectifs de de et hl (puisque le saut
						;n'a pas t fait).
 djnz boucle1detectgard
 jr boucle2detectgard


;Affichage de la premire partie de la squence graphique lorsque le gardien arrte le tir dans la zone du...
pasbutmilieum:	;...milieu de la cage
 ld de,PLOTSSCREEN+(((24+13)*12)+4-3)	;On place dans de l'adresse du dbut de la zone concerne moins trois,
										;car la boucle incrmente de de trois avant de comparer sa valeur 
										;l'adresse d'affichage du ballon contenue dans hl.
 ld b,((12*4)-2)						;Car il y a 12 lignes, donc 12*4-2 (l'octet 3 de la premire ligne de
 jr bouclemilieu						;la zone et le 11 de la dernire ligne ne sont pas tests, d'o le
										;"-2", voir plus loin). 12*4-2 = 46.
pasbutmilieub:	;...bas de la cage (dans les deux cas, on utilise le sprite du gardien initial)
 ld b,((3*4)-2)								;Cette fois-ci, il n'y a que trois lignes possibles : 3*4-2 = 10.
 ld de,PLOTSSCREEN+(((24+13+12)*12)+4-3)	;De plus, on se trouve dans la zone du bas au milieu.
bouclemilieu:	;Boucle de tests de la prsence du ballon.
 inc de					;Cette boucle teste successivement les octets 5 et 8, puis 11 (premire ligne) et 3
 inc de					;(ligne suivante). Une itration de la boucle quivaut  un test. Ainsi, on voit que
 inc de					;le nombre de tests (10 ou 46) est suprieur au nombre ncessaire (6 ou 24) puisqu'il
	bcall(_cphlde)		;suffit de tester les octets 5 et 8 de chaque ligne pour savoir  quel emplacement
 jr z,milieubasgd		;on doit copier le sprite du gardien. Cela s'explique par le choix d'une optimisation
 djnz bouclemilieu		;en taille, et non en vitesse. Le Z80 va faire plus de tests (en executant notamment la
						;ROMCALL _cphlde  chaque itration, mais le programme prendra moins de place. La
						;vitesse d'execution n'ayant pas une grande importance dans ce jeu quasi-statique, ce
						;choix est totalement justifi.
 call gardieninitial	;Si aucun test de la boucle ne s'avre juste, on copie le sprite du gardien en position
						;initiale, car le ballon est tir en bas, au milieu, sur un octet 6 ou 7.

 jr affichage2			;Affichage du graph buffer.

milieubasgd:	;Dbut du code copiant le sprite du gardien  une adresse dcale d'un octet  gauche ou 
				;droite de la position initiale.
 ld hl,PLOTSSCREEN+(37*12+4)	;Adresse de copie dcale  gauche.
 bit 0,b						;Si b a une valeur impaire (Low Significant Bit  1), le ballon est copi sur
 jr z,milieubasgdsuite			;l'octet 8 d'une ligne, donc on affiche le sprite du gardien  droite par
 inc hl							;rapport au sprite initial. D'o les deux "inc hl".
 inc hl							;ATTENTION : le drapeau z est  1 quand le bit test est  0 et inversement.
milieubasgdsuite:
 call gardieninitialbis			;Si b est pair, on affiche le sprite  gauche de la position initiale.
 jr affichage2					;Affichage du graph buffer.


pasbutmilieuh:
 ld de,-12					;On veut copier le sprite du gardien  partir de l'octet situ au dessus de l'octet
 add hl,de					;de dbut du sprite du ballon.
 ld de,gardienhaut
 ld bc,$1501				;$1501 = 21 lignes et 1 seule colonne.
jraffichage1:
 jr affichage1				;Saute  l'affichage de l'action.


affichage1mir:
 call affspritemiroir		;Copie le sprite dans le graph buffer en lui appliquant l'effet "miroir".
 jr affichage2
affichage1:
 call affsprite				;Copie le sprite dans le graph buffer.
affichage2:					;Affiche le graph buffer  l'cran
 call IonFastcopy
 ld b,100					;Charge 100 dans b afin de rgler le sous-programme de temporisation.
 call tempo					;Appelle un sous-programme de temporisation.
 call affcage				;Appelle le sous-programme d'affichage de la cage.
; jp calcresult

;Calcul du rsultat de la squence.

calcresult:		;dtermine s'il y a but.

 ld a,(result)	;
 or a			;Teste si (result)=0.
 jr z,arret		;Si oui, va  arret (car le tireur a chou), sinon, on continue
				;l'excution, qui nous conduit naturellement  but.

;Incrmente le compteur de buts de celui qui a marqu...

but:				;affiche "goal" et incrmente le compteur de buts du tireur s'il y a but.

 ld a,(ordretir)
 or a				;Compare a  0 (or a = cp 0, mais occupe un octet de moins).
 jr z,but10			;Si a=0, alors cela signifie que c'est le joueur 1 qui tirait.
 ld hl,bj2		;Incrmentation du compteur de buts du joueur 2.
 inc (hl)			;Si a<>0, on incrmente le compteur de buts du joueur 2.
 ld a,14			;Charge la valeur que l'on veut affecter  (penrow) pour choisir
 jr affgoal			;l'endroit de l'cran o on va afficher "goal !!", puis saute
					;au dbut du code qui affiche "goal !!".

but10:			;Incrmentation du compteur de buts du joueur 1.
 ld hl,bj1			;Place l'adresse de la variable (bj1) dans hl.
 inc (hl)			;Incrmente le contenu de la case mmoire dont l'adresse est comprise dans hl.
 ld a,7				;Charge la valeur que l'on veut affecter  penrow pour choisir
					;l'endroit de l'cran o on va afficher "goal !!", puis continue
					;au dbut du code qui affiche "goal !!".
 
affgoal:		;Affichage de la mention indiquant qu'un but vient d'tre marqu.
 ld (penrow),a		;Charge la variable relative  la ligne o l'on souhaite afficher "goal".
 ld hl,dispgoal		;Charge dans hl l'adresse o se trouve le dbut des donnes relatives au
					;message "goal".
affsucces:		;Lancement du clignotement du message.
 call cligno		;Ainsi, cligno est execute deux fois (car le label "cligno:" suit juste aprs).

;Affichage et clignotement d'une inscription en petites lettres.
;entres : hl = adresse du texte  afficher ; penrow

cligno:
 ld a,70						;"L'abcisse" du message est fixe par la valeur
 ld (pencol),a					;charge avec a  l'adresse pencol.
 push hl						;Sauvegarde le contenu de hl dans la pile.
	bcall(_vputs)				;Affiche le message situ  l'adresse contenue dans hl.
 call tempoa					;Appelle le sous-programme effectuant la temporisation. La
								;valeur de a sert ainsi aussi  rgler la dure de la
								;temporisation, voir (tempoa:).
 set TextInverse,(iy+TextFlags)	;Active le "System Flag" permettant d'inverser les couleurs
								;(lettres blanches sur fond noir) des textes affichs par
								;_vputs, _vputmap... Ce rglage n'affecte videmment que les
								;messages affichs par la suite (pas d'effet retro-actif).
								;On va donc rafficher l'inscription.
 ld (pencol),a					;Rinitialise (pencol)  la valeur de a qui
 								;n'a pas boug depuis sa dernire affectation.
 pop hl							;Rcupre l'adresse du message (dtruite par _vputs).
 push hl						;Sauvegarde celle-ci  nouveau.
	bcall(_vputs)				;Affiche le message situ  l'adresse contenue dans hl.
 pop hl							;Rcupre l'adresse du message (dtruite par _vputs).
 res TextInverse,(iy+TextFlags)	;Dsactive le "System Flag" d'inversion du texte.
 jr tempoa						;Le code suivant le label "tempoa:" contient un "ret", ce qui
								;permet d'en conomiser un ici. Le code en question (les
								;lignes situes entre "tempoa:" et "ret") cre une temporisation.

;Affichage de la mention "ARRET".

arret:
 ld (result),a		;Grce  sub (voir droite, milieu et gauche), a vaut zro.
 ld hl,$3900		;Charge dans hl l'adresse du graph buffer correspondant  l'endroit
					;de l'cran o on veut afficher le message "ARRET".
 ld (pencol),hl		;Initialise les coordonnes utilises par la ROM_CALL _vputs.
 ld hl,disparret	;Charge dans hl l'adresse de stockage du message "ARRET".
	bcall(_vputs)	;Affiche "ARRET" puisqu'il n'y a pas but.
 ld a,100			;Configure la dure de la temporisation (elle durera environ 1/2s).
; jr tempoa

;Boucle de temporisation [comme on en fait en STI lec ;)].				

tempoa:
 ld b,a			;a=70 ou 100 selon les cas (voir plus haut).
tempo:			;L'utilisation de "halt" permet d'conomiser de l'nergie. Par
 ei				;contre, la dure de "halt" dpend de la frquence des
				;interruptions. Or, celles-ci sont de moins en moins frquentes
tempo1:			;au fur et  mesure que les piles (lectriques) se dchargent. La
 halt			;dure de la temporisation dpend donc de la vitalit des piles.
 djnz tempo1	;Thoriquement, pour la squence relative au but (a=70),
				;elle dure environ :
 ret			;70*(1/200)secondes + (4+7+(100*4)+(99*13)+8+10)cycles
				;= 0,35s + 1716*(1/6000000)s
				;= 0,35s + 0,000286s
				;environ gal  0,35s, en ngligeant l'effet de dcharge des batteries. :)


;Prise en compte de l'volution du nombre de tirs restants et du score.

compteur:		;Change l'ordretir selon le tireur prcdent et le nbre de tirs restants.
 ld a,(ordretir)
 or a			;Dtermine qui vient de tirer.
 jr z,csuiteo	;Si c'est le joueur 1, on va  csuiteo.
 ld hl,ntirs2	;Sinon, on incrmente le
 inc (hl)		;nombre de tirs du joueur 2.
 dec hl			;Charge l'adresse de ntirs1 dans hl.
 xor a			;On va modifier la valeur de ordretir afin que le joueur 1 tire au coup
				;suivant (s'il y a).
 jr csuite2

csuiteo:
 inc a			;Modifie la valeur de (ordretir) pour que ce soit au joueur 2 de tirer.
 ld hl,ntirs1	;Incrmente le compteur de tirs du joueur 1,
 inc (hl)		;car il vient de tirer.

csuite2:
 ld (ordretir),a	;On enregistre la nouvelle valeur de (ordretir).

 ld a,(ntirs)
 cp (hl)			;vrifie si ntirs est dpass par ntirs1
 jp p,normal		;Sinon, va  la dtermination normale. Si oui...
 ld a,(ordretir)	;...
 or a				;Quitte le compteur si le joueur 2 va tirer, car il lui reste
 ret nz				;forcment une chance d'galiser.
 ld a,(bj1)			;On compare alors le nombre de buts du joueur 1 et du joueur 2.
 ld hl,bj2			;
 cp (hl)			;
 ret z				;S'ils sont gaux, il faut tirer  nouveau. Sinon, on continue
 ld a,14			;l'execution  "testt:" pour valider la victoire du joueur 1 et 
 jp m,testtt		;"testttt:" pour valider la victoire du joueur 2.
testt:
 ld a,7
testtt:
 ld (penrow),a
 ld a,2				;Code de fin de squence.
 ld (ordretir),a


 ld hl,dispsucces
; call affsucces
 jr affsucces
; ret

;Recopie dans la mmoire grapique d'une partie de l'image.

						;Dcompression d'une partie de l'image code en RLE
affcage:				;dans la mmoire graphique (graph buffer).
 ld de,PLOTSSCREEN+288	;Adresse o l'on met le rsultat de la dcompression.
 ld hl,cage+9			;Dbut des donnes  dcompresser.
 ld bc,480				;Nombre d'octets  dcompresser.
 jr Decompress			;Appel de la routine de dcompression RLE.
; call Decompress
; ret


dispsucces:
 .db "succes!",0

normal: 
 ld hl,ntirs	;
 ld a,(hl)		;ld a,(ntirs)
 inc hl			;hl = ntirs1
 sub (hl)		;
 ld b,a			;b = (ntirs) - (ntirs2)
 add a,(hl)		;a = (ntirs)
 inc hl			;hl = ntirs2
 sub (hl)		;
 ld c,a			;c = (ntirs) - (ntirs2)
 ld hl,(bj1)	;
 ld a,l			;a = (bj1)
 sub h			;a = (bj1) - (bj2)
 inc c			;
 cp c			;Compare [(bj1) - (bj2)]  [(ntirs) - (ntirs2) + 1]. L'incrmentation
 jp p,testt		;sert  viter qu'en cas d'galit, le saut soit effectu, car le
				;drapeau p accepte le zro comme nombre positif (c'est conventionnel).
 neg			;a = (bj2) - (bj1)
 inc b			;
 cp b			;Comparer [(bj2) - (bj1)]  [(ntirs) - (ntirs1) + 1]. L'incrmentation
 ld a,14		;
 jp p,testtt	;sert  viter qu'en cas d'galit, le saut soit effectu, car le
				;drapeau p accepte le zro comme nombre positif (c'est conventionnel).
 ret			;Si le match n'est pas termin, on continue.


;
;
;ROUTINES GENERALES
;
;


;Routine de dcompression RLE. Auteur : David Phillips.
;optimisation : Clem V. et Aaron Curtis.

;Input:
;HL = Compress From
;DE = Compress To
;BC = Bytes to Decompress

Decompress1:
 ld de,PLOTSSCREEN
Decompress:
    ld a, (hl)
    cp $91
    jr z,DispRLERun
    ldi
DispRLEC:
    ret po
    jr Decompress
DispRLERun:
    inc hl
    inc hl
    ld a,(hl)
DispRLERunL:
    dec hl
    dec a
    ldi
    jr nz, DispRLERunL
    inc hl
    jr DispRLEC

;Routine waitkey transforme pour gnrer un nombre alatoire.
;La routine waitkey originale est un getkey qui permet d'viter que l'utilisateur
;n'teigne sa calculatrice durant un getkey, ce qui provoque un reset. Pour cela,
;il utilise la ROM_CALL _getcsc qui permet de ne pas prendre en compte les fonctions
;secondaires des touches.
;entre b = limite suprieure naturelle non incluse du domaine de c
;sortie a = touche presse
;sortie c = nombre alatoire appartenant  [0;b[
;sortie (aleatoire) = Nombre alatoire appartenant  [0;$FF]
;registres dtruits : af, c, hl, b si utilisation d'introwaitkey2.


introwaitkey2:
 ld b,9
waitkey2:
 ei				;Autorise les interruptions.
c0:
 ld c,-1
WKA_loop2:
 ld hl,aleatoire
 inc (hl)
 inc c
 ld a,b
 cp c
 jr z,c0
 HALT
	icall(_getcsc)		;dtruit af, hl
 or a
 jr z,WKA_loop2
;Gestion de la sortie d'urgence.
 cp skClear			;Dtecte l'appui sur le bouton "Clear".
 jr z,sortie		;Saute  la procdure de sortie du programme.
;Fin de la gestion de la sortie d'urgence.
 ret

;Sortie du programme.
sortie:
 set appTextSave,(iy+appflags)	;Ractive le flag de sauvegarde de l'cran texte.
 ei								;Active les interruptions, au cas o celles-ci seraient
								;dsactives
 ld sp,(adresortie)	;Place le pointeur de la pile de manire  pouvoir quitter
					;le programme avec le "ret" suivant. Ainsi, quel que soit
					;le nombre de donnes stockes dans la pile depuis le lancement
					;du programme, on peut quitter celui-ci instantanment.
 ret				;Retourne  l'adresse suivant celle d'o a t appel
					;PENO FOOTBALL.

 
;Routine de copie de sprite dans le graph buffer (or).
;par Joe 14.
;entre hl = adresse de placement du premier octet dans le graph buffer.
;entre de = adresse du premier octet du sprite.
;entre b = Hauteur du sprite en nombre de lignes.
;entre c = largeur du sprite en nombre d'octets.

affsprite:
 push bc			;Sauve b et c dans la pile.
 ld b,c				;Charge c dans b afin d'initialiser la boucle [djnz - affsprite3].
affsprite3:
 ld a,(de)
 or (hl)			;Oprateur logique "ou" entre les octets (de) et (hl).
 ld (hl),a			;Copie de l'octet obtenu dans le graph buffer.
 inc de				;
 inc hl				;Incrmentation de hl et de afin de passer  l'octet suivant.
 djnz affsprite3	;Selon la valeur de b, continue ou non la ligne en cours.
 ld a,12			;12 est le nombre d'octets par ligne.
 sub c				;Selon la largeur du sprite, l'adresse de dbut d'une ligne varie.
 ld c,a				;Prpare le passage  la ligne suivante.
 add hl,bc			;Passe le curseur li au graph buffer  la ligne suivante.
 pop bc				;Rcupre les valeurs de b et c.
 djnz affsprite		;Dcide, selon la valeur de b, si la copie est finie ou non.
 ret				;Va  l'adresse suivant "call affsprite".


;Routine de copie de sprite dans le graph buffer (or) avec effet miroir.
;par Joe 14.
;entre hl = adresse de placement du premier octet dans le graph buffer.
;entre de = adresse du premier octet du sprite.
;entre b = Hauteur du sprite en nombre de lignes.
;entre c = largeur du sprite en nombre d'octets.

affspritemiroir:
 di							;Dsactive les interruptions afin d'utiliser les registres fantmes.
affspritem2:
 push bc					;Sauve b et c dans la pile.
 ld b,c						;Charge c dans b afin d'initialiser la boucle [djnz - affsprite3].
affspritem3:
 ld a,(de)					;Charge l'un des octets du sprite dans l'accumulateur.
miroir:
 exx				;+1		;Si le mode miroir est activ, on change bc, de et hl avec bc', de'
							;et hl' pour pouvoir utiliser bc, de et hl dans la routine qui modifie
							;un octet de la faon suivante : %01110100 => %00101110. C'est comme si
							;l'octet tait lu de droite  gauche.
 ld c,a				;+1		;Charge l'octet (de) dans c par l'intermdiaire de a.

;Routine transformant un octet par effet miroir
;(application d'une symtrie par rapport au "milieu" de l'octet).
;par Joe 14.
;input c = octet  "miroiriser"
;output b = octet "miroiris"

;Le principe de cette routine, c'est qu'elle teste successivement les 8 bits de c et, selon l'tat de ceux-ci,
;modifie les bits de b. Aprs avoir rcupr la valeur du bit X (X compris entre 0 et 7) de c, on copie cette
;valeur dans le bit 7-X de b. Or, le Z80 instruction set nous apprend que le deuxime octet de la commande
;"bit X,r" (avec b, bit entre 0 et 7) se forme comme suit : %01[X]001 o X est exprim en binaire. De plus, les
;commandes "res N,r" et "set N,r" (et mme "bit N,r" ; avec N compris entre 0 et 7 et r un registre 8 bits) ont un
;premier octet, $CB, en commun. Il suffit donc de faire varier le second pour faire changer la commande au
;gr des besoins. Les second octets se forment comme suit : %11[N]000 pour "set N,b" et %10[N]000 pour "res N,b".
;Enfin, pour obtenir 7-X, il suffit de faire un "xor" avec X et %111 et le rsultat est 7-X. Si vous comprenez
;ceci, vous devriez comprendre la routine...:)

;;;[SELF MODIFYING CODE;;;
 ld hl,boucle2+1	;+3		;Prpare la modification du code.
 ld (hl),%00111001	;+2		;Modifie le code
;;;SELF MODIFYING CODE];;;
boucle:
 ld a,(hl)			;+1
 rrca				;+1
 rrca				;+1
 rrca				;+1
 inc a				;+1
 rlca				;+1
 rlca				;+1
 rlca				;+1
;;;[SELF MODIFYING CODE;;;
 ld (hl),a			;+1
;;;SELF MODIFYING CODE];;;
 cp %10000001		;+2
 jr z,stop			;+2
boucle2:
;;;[SELF MODIFYING CODE;;;
 bit 0,c			;+2
;;;SELF MODIFYING CODE];;;
 jr nz,bit1			;+2
 ld a,%11111001		;+2
bit11:
 xor (hl)			;+1
;;;[SELF MODIFYING CODE;;;
 ld (bit11+5),a		;+3
 res 0,b			;+2
;;;SELF MODIFYING CODE];;;
 jr boucle			;+2
bit1:
 ld a,%10111001		;+2
 jr bit11			;+2

stop:
 ld a,b				;+1
 exx				;+1

;Fin de la routine d'application de l'effet miroir et dbut de la partie de affsprite modifie

 or (hl)			;Oprateur "ou" entre les octets (de) et (hl).
 ld (hl),a			;Copie de l'octet obtenu dans le graph buffer.
 inc de				;
 dec hl				;Dcrmentation de hl et de afin de passer  l'octet prcdent.
 djnz affspritem3	;Selon la valeur de b, continue ou non la ligne en cours.
 ld a,12			;12 est le nombre d'octets par ligne
 add a,c			;Selon la largeur du sprite, l'adresse de dbut d'une ligne varie.
 ld c,a				;Prpare le passage  la ligne suivante.
 add hl,bc			;Passe le curseur li au graph buffer  la ligne suivante.
 pop bc				;Rcupre les valeurs de b et c.
 djnz affspritem2	;Dcide, selon la valeur de b, si la copie est finie ou non.
 ret				;Va  l'adresse suivant "call affspritemiroir".

;Routine de dcompression VRLE.
;version lgre (Light VRLE)
;********************************************************
; -Cette routine dcompresse les donnes compresses
; verticalement par Image studio v. 2.0 de Cullen Sauls. C'est une 
; adaptation de la routine de dcompression que Levi Lansing
; a crite (TI86) pour utiliser avec son logiciel bmp2asm.
; L'adaptation a t ralise par joe14 (MYP).
; -(dcompresse les donnes dans le graph buffer - 768 octets)
; -de=adresse de dbut des donnes  dcompresser
; -registres "dtruits" : a,bc,hl,de
;********************************************************
LVRLE:
 ld hl,PLOTSSCREEN	;Place le pointeur hl  la premire adresse du graph buffer.
LVRLELoop:
 ld a,(de)			;Charge le prochain octet  traiter dans a pour faire une comparaison.
 inc de				;Avance le pointeur de.
 cp $91				;Regarde si la valeur contenue dans a est un marqueur :
 jr z,LVdecinit		;si oui, entame une decompression. Sinon, traite l'octet normalement.
 ld (hl),a			;Copie l'octet non compress dans l'adresse correspondante du
 ld bc,12d			;Graph buffer. Prpare le changement de ligne (12 octets par ligne).
 add hl,bc			;Fait passer le pointeur hl  l'octet situ au-dessous du prcdent.
 ld a,h				;Vrifie que le pointeur hl n'a pas dpass la limite du graph buffer.
#ifdef TI83P		;Cette limite tant diffrente pour chaque calculatrice et non
 cp $96				;remarquable (sauf sur 86), il existe plusieurs versions de la routine.
#endif
#ifdef	TI83
 cp $91
#endif
#ifdef TI82
 cp $8B
#endif
 jr nz,LVRLEloop	;Si le pointeur hl n'a pas dpass la limite, on retourne  la dtection
 ld a,l				;de marqueur. Sinon, on dtecte une ventuelle fin de dcompression.
#ifdef TI83P		;L aussi, il faut faire des versions diffrentes.
 cp $40
#endif
#ifdef	TI83
 cp $29
#endif
#ifdef TI82
 cp $B8
#endif
 jp m,LVRLEloop
 ld bc,-767			;Le pointeur hl ayant dpass la limite, on soustrait  celui-ci le nombre
 add hl,bc			;d'octets de l'cran (768) et on incrmente (768+1=767) afin de se placer
 ld a,l				; l'adresse du premier octet de la colonne suivante. On vrifie si le
#ifdef TI83P		;pointeur hl se trouve  l'adresse du second octet de la premire colonne.
 cp $4C
#endif
#ifdef	TI83
 cp $35
#endif
#ifdef TI82
 cp $C4
#endif
 jr nz,LVRLELoop	;Si ce n'est pas le cas, on continue la dcompression.
 ret				;Si c'est le cas, la dcompression est termine. La routine se termine.
LVdecinit:			;Initialisation de la dcompression.
 ld a,(de)			;On charge l'octet  recopier dans c.
 ld c,a				;
 inc de				;Le prochain octet indique combien de fois il faut le recopier.
 ld a,(de)
 ld b,a				;On le charge dans b afin d'utiliser la commande "djnz". On place ensuite
 inc de				;le pointeur de sur le prochain octet (qui sera examin plus tard).
LDCrepeatLoop:		;Boucle de dcompression.
 ld (hl),c			;On copie l'octet de c dans le graph buffer.
 push bc			;On sauvegarde bc afin de l'utiliser dans les oprations suivantes.
 ld bc,12d
 add hl,bc			;Cela place le pointeur hl sur la ligne suivante.
 ld a,h				;On vrifie que hl n'tait pas  la dernire ligne du graph buffer
#ifdef TI83P		;avant l'avance de 12.
 cp $96
#endif
#ifdef	TI83
 cp $91
#endif
#ifdef TI82
 cp $8B
#endif
 jr nz,LDCloop		;Si cela n'est pas le cas, on va  la suite de la boucle.
 ld a,l				;On effectue cette comparaison en deux fois, car elle porte sur une
#ifdef TI83P		;adresse (16 bits).
 cp $40
#endif
#ifdef	TI83
 cp $29
#endif
#ifdef TI82
 cp $B8
#endif
 jp m,LDCloop		;Si cela n'est pas le cas, on va  la suite de la boucle.
 ld bc,-767d		;Comme le pointeur hl est en dehors du graph buffer, on le fait changer
 add hl,bc			;de colonne et on vrifie qu'il n'tait pas  la dernire colonne avant.
 ld a,l
#ifdef TI83P
 cp $4C				;Lorsque l vaut : TI83+=4Ch, TI83=35h, TI82=C4h, le graph buffer
#endif				;est plein.
#ifdef	TI83
 cp $35
#endif
#ifdef TI82
 cp $C4
#endif
 jr nz,LDCloop		;Si l n'est pas gal aux valeurs attendues, on continue la boucle.
 pop bc				;Si l est gal aux valeurs attendues, on rtablit bc et
 ret				;on retourne  l'endroit d'o a t appele la routine.
LDCloop:
 pop bc				;On rtablit bc pour le "djnz" et c pour le copier dans hl si la boucle
 djnz LDCrepeatLoop	;continue. Relance une boucle de copie de c tant que b est diffrent
					;de zro. Si b vaut zro, on effectue la commande suivante.
 jr LVRLELoop		;On continue avec le prochain octet (situ actuellement dans de).


;
;
;SPRITES
;
;


myp:
 .db %10001100
 .db %11011010
 .db %10101100
 .db %10101000
 .db %10101000

tpballon:
 .db %00011000
 .db %00111100
 .db %00111100
 .db %00011000

tgballon:
 .db %00000001,%11000000
 .db %00000011,%11100000
 .db %00000111,%11110000
 .db %00000111,%11110000
 .db %00000111,%11110000
 .db %00000011,%11100000
 .db %00000001,%11000000

gardien1:
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000111
 .db %00001111
 .db %01001111
 .db %11111011
 .db %01110011
 .db %00000011
 .db %00000011
 .db %00000011
 .db %00000011
 .db %00000110
 .db %00001100
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000

gardienhaut:
 .db %00011000
 .db %00111100
 .db %01100110
 .db %11011011
 .db %11011011
 .db %01111110
 .db %00111100
 .db %00111100
 .db %00111100
 .db %00111100
 .db %00111100
 .db %00111100
 .db %00111100
 .db %01100110
 .db %01100110
 .db %01100110
 .db %01100110
 .db %01100110
 .db %01100110
 .db %01100110
 .db %01100110

gardiengauchebas:
 .db %00000000,%00000000,%00000110
 .db %00000000,%11000000,%00011110
 .db %00000111,%11110000,%01111000
 .db %00000111,%11111111,%11100000
 .db %00010001,%11111111,%10001110
 .db %00011111,%00111111,%11111110
 .db %00001110,%00001111,%11110000

gardiengauchemilieu:
 .db %00000000,%00000000,%00000000
 .db %00000111,%11000000,%00000000
 .db %00111111,%11110000,%00000010
 .db %00011111,%11111100,%11100110
 .db %00000111,%11111111,%01111111
 .db %00000000,%00111111,%11100110
 .db %00000000,%00001111,%01111110

gardiengauchehaut:
 .db %11000000,%00000000,%00000000
 .db %01100110,%00000000,%00000000
 .db %00111011,%00000000,%00000000
 .db %00111111,%11110000,%00000000
 .db %00000011,%11011100,%00000000
 .db %00000001,%11100110,%00000000
 .db %00000000,%11110000,%00000000
 .db %00000000,%01111000,%00000000
 .db %00000000,%00111100,%00000000
 .db %00000000,%00110110,%00000000
 .db %00000000,%00110011,%00000000
 .db %00000000,%00110001,%11111000
 .db %00000000,%00011100,%01111000
 .db %00000000,%00000111,%00000000


;
;
;IMAGES
;
;


;Ecran de jeux.
;Compresse en RLE  l'aide du logiciel image studio v. 2.0 de Cullen Sauls.
;Compressed 768 bytes to 189. 24% of original size.

cage:
 .db $91,$FF,$FC,$91,$00,$0C,$91,$FF,$18,$E4,$92,$49,$24,$92,$49,$24
 .db $92,$49,$24,$92,$4B,$D6,$DB,$6D,$B6,$DB,$6D,$B6,$DB,$6D,$B6,$DB
 .db $6F,$E9,$24,$92,$49,$24,$92,$49,$24,$92,$49,$24,$93,$D5,$B6,$DB
 .db $6D,$B6,$DB,$6D,$B6,$DB,$6D,$B6,$DB,$DB,$91,$FF,$0B,$E6,$91,$88
 .db $0A,$8B,$D2,$91,$88,$0A,$8B,$DB,$91,$77,$0B,$E6,$91,$88,$0A,$8B
 .db $D2,$91,$88,$0A,$8B,$DB,$91,$77,$0B,$E6,$91,$88,$0A,$8B,$D2,$91
 .db $88,$0A,$8B,$DB,$91,$77,$0B,$E6,$91,$88,$0A,$8B,$D2,$91,$88,$0A
 .db $8B,$DB,$91,$77,$0B,$E6,$91,$88,$0A,$8B,$D2,$91,$88,$0A,$8B,$DB
 .db $91,$77,$0B,$E6,$91,$88,$0A,$8B,$D2,$91,$88,$0A,$8B,$DB,$91,$77
 .db $0B,$E6,$91,$88,$0A,$8B,$D2,$91,$88,$0A,$8B,$DB,$91,$77,$0B,$E6
 .db $91,$88,$0A,$8B,$D2,$91,$88,$0A,$8B,$DB,$91,$77,$0B,$E6,$91,$88
 .db $0A,$8B,$D2,$91,$88,$0A,$8B,$91,$FF,$0C,$91,$00,$60



;Image de l'aide.
;Compresse en Vertical RLE  l'aide du logiciel image studio v. 2.0 de Cullen Sauls
;Compressed 768 bytes to 295. 38% of original size.

picaide:
 .db $08,$6B,$AA,$AA,$6B,$02,$91,$00,$05,$3F,$3C,$3C,$3C,$91,$00,$13
 .db $D1,$AA,$AA,$89,$00,$3F,$3C,$20,$20,$00,$15,$08,$08,$14,$00,$3F
 .db $20,$3C,$20,$00,$00,$05,$02,$02,$05,$00,$3F,$20,$20,$3C,$20,$21
 .db $B2,$AA,$29,$00,$01,$00,$00,$01,$00,$F8,$08,$08,$08,$91,$00,$12
 .db $24,$B4,$A6,$A5,$95,$00,$F8,$08,$08,$08,$20,$A0,$20,$00,$00,$00
 .db $F8,$08,$08,$08,$40,$20,$40,$60,$00,$00,$00,$F8,$08,$08,$08,$00
 .db $91,$80,$04,$00,$5C,$89,$89,$48,$00,$7F,$47,$47,$47,$91,$00,$11
 .db $6C,$AA,$AA,$6C,$08,$00,$00,$7F,$47,$40,$40,$04,$31,$25,$15,$35
 .db $00,$7F,$40,$47,$40,$00,$00,$06,$06,$02,$04,$00,$7F,$40,$40,$47
 .db $00,$01,$01,$00,$01,$00,$CC,$AA,$6A,$CA,$00,$F0,$10,$10,$10,$91
 .db $00,$11,$CC,$A9,$A5,$CD,$81,$01,$00,$F0,$10,$10,$10,$00,$80,$40
 .db $40,$40,$00,$F0,$10,$10,$10,$91,$00,$07,$F0,$10,$10,$10,$20,$B3
 .db $25,$A5,$93,$91,$00,$06,$FF,$81,$81,$81,$91,$00,$12,$94,$59,$51
 .db $90,$00,$00,$FF,$81,$80,$80,$00,$24,$4A,$4A,$24,$00,$FF,$80,$81
 .db $80,$00,$04,$08,$08,$08,$04,$00,$FF,$80,$80,$81,$46,$64,$42,$46
 .db $20,$04,$06,$04,$04,$02,$00,$E4,$EA,$EA,$E4,$00,$0C,$0A,$0A,$0C
 .db $08,$91,$00,$0C,$DA,$15,$55,$D1,$00,$00,$E4,$E6,$24,$24,$02,$C0
 .db $84,$40,$C4,$04,$E4,$20,$E5,$26,$04,$04,$91,$00,$05,$E0,$20,$20
 .db $E0,$91,$00,$FF,$91,$00,$81

.end